﻿'Imports Fireblade.MMM.Reportmanager
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid
Imports Infragistics.Win.UltraWinGrid.ExcelExport
'Imports Meritsoft.GolfRez.AddIns
'Imports Meritsoft.POS.Logging
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data.SqlClient
Imports System.Drawing
Imports System.IO
Imports System.Runtime.InteropServices
Imports System.Windows.Forms

'<AddInDescriptor("en", "Financial Statements", "Allows the user to view financial statements.")>
'<AddInMenuDescriptor("en", "Financial.Financial Statements", MenuImage:="Graph-13")>
'<ApplicationExtender(AddInTarget.MemberManager)>
Public Class Form1
    'Implements IApplicationExtenderAddInTypeOne
    'Implements ISecuredFeature

#Region "fields, ctor and load"

    Private Enum DataSourceMode
        IncomeStatement
        BalanceSheet
    End Enum

    'Private db As Meritsoft.GolfRez.Data.Database
    'Private WithEvents sm As SecurityManager
    Private m_oConn As IDbConnection
    Private dSource As New BindingList(Of NodeObject)
    Private isWorking As Boolean = False

    Private m_FiscalPeriodsDT As DataTable
    Private m_CurrentSegmentOne As String
    Private m_CurrentSegmentTwo As String
    Private m_CurrentSegmentThree As String
    Private m_CurrentFiscalPeriod As Integer
    Private m_IsInitialLoad As Boolean
    Private m_CurrentLayoutKey As Integer
    Private m_LayoutsDataSource As DataTable
    Private m_SegmentsDataSource As New DataSet()
    Private RightClickRow As UltraGridRow = Nothing
    'Private m_frmReport As frmReportManager
    Private WithEvents c_pdSetup As New System.Drawing.Printing.PrintDocument()
    Friend WithEvents PageSetupDialog1 As New System.Windows.Forms.PageSetupDialog()
    Private m_DataSourceMode As DataSourceMode = DataSourceMode.IncomeStatement
    Private m_RetainedEarningsGLAccount As String
    'Private posSettings As Business.POSSettings
    'Private m_ClubLogo As String
    Private HierarchyColors As Dictionary(Of Integer, Color)

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        'Dim con As New SqlClient.SqlConnection("Server=vm-db;Database=kyc;Trusted_Connection=False;user id=sa;password=!1qazxsw2@;Connection Timeout=90;Persist Security Info=True;")
        'Dim cmd As New SqlClient.SqlCommand()
        'Dim ada As New SqlClient.SqlDataAdapter(cmd)
        'cmd.Connection = con
        'con.Open()

        'Dim Xresults As New DataSet()
        'cmd.CommandType = CommandType.StoredProcedure
        'cmd.CommandText = "proc_report_financial_statement"


        'cmd.Parameters.Add("@fiscalperiod", SqlDbType.Int)
        'cmd.Parameters.Add("@StatementType", SqlDbType.Char, 2)
        'cmd.Parameters.Add("@SegmentOne", SqlDbType.VarChar)
        'cmd.Parameters.Add("@SegmentTwo", SqlDbType.VarChar)
        'cmd.Parameters.Add("@SegmentThree", SqlDbType.VarChar)

        'cmd.Parameters("@StatementType").Value = "IS"
        'cmd.Parameters("@SegmentOne").Value = " "
        'cmd.Parameters("@SegmentTwo").Value = " "
        'cmd.Parameters("@SegmentThree").Value = " "
        'cmd.Parameters("@fiscalperiod").Value = 43

        'ada.Fill(Xresults)

        'Xresults.WriteXml(Environment.CurrentDirectory & "\Xresults.xml", XmlWriteMode.WriteSchema)


        



    End Sub

    Private Sub frmIncomeStatementsUltraGrid_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        HierarchyColors = New Dictionary(Of Integer, Color)()
        HierarchyColors.Add(0, Color.White)
        HierarchyColors.Add(1, Color.SeaShell)
        HierarchyColors.Add(2, Color.PapayaWhip)
        HierarchyColors.Add(3, Color.OldLace)
        HierarchyColors.Add(4, Color.LightCyan)
        HierarchyColors.Add(5, Color.Ivory)
        HierarchyColors.Add(6, Color.Honeydew)
        HierarchyColors.Add(7, Color.Gainsboro)
        HierarchyColors.Add(8, Color.Cornsilk)
        HierarchyColors.Add(9, Color.Beige)

        Try
            m_IsInitialLoad = True

            BindDataGrid("", "", "", m_CurrentFiscalPeriod)

            m_IsInitialLoad = False

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

#End Region

    '#Region "IApplicationExtenderAddInTypeOne and ISecuredFeature implementations"

    '    Private m_NoLogin As Boolean

    '    Private Sub sm_CurrentUserChangedEventHandler(e As SecurityManagerEventArgs) Handles sm.CurrentUserChangedEventHandler
    '        If Not (sm.CurrentUser Is Nothing) Then
    '            CheckSecurityAccess()
    '            m_NoLogin = False
    '            btnExportToExcel.Enabled = True
    '            btnPrint.Enabled = True
    '            ContextMenuStripRightClick.Enabled = True
    '            ugridFinancialStatements.Enabled = True
    '            m_menuItems_Layouts.Enabled = True
    '            m_menuItemsSub_FiscalYears.Enabled = True
    '            m_menuItemsSub_FiscalMonths.Enabled = True
    '            btnSegments.Enabled = True
    '            sepSegments.Enabled = True
    '            btnDataSourceMode.Enabled = True
    '            lblFiscalPeriod.Enabled = True

    '        Else
    '            'lockitdown
    '            btnExportToExcel.Enabled = False
    '            ugridFinancialStatements.Enabled = False
    '            btnPrint.Enabled = False
    '            btnSaveLayoutzz.Enabled = False
    '            btnDeleteLayoutzz.Enabled = False
    '            btnUpdateLayoutzz.Enabled = False
    '            'btnLoadLayoutzz.Enabled = False
    '            m_menuItems_Layouts.Enabled = False
    '            m_menuItemsSub_FiscalYears.Enabled = False
    '            m_menuItemsSub_FiscalMonths.Enabled = False
    '            btnSegments.Enabled = False
    '            sepSegments.Enabled = False
    '            btnDataSourceMode.Enabled = False
    '            lblFiscalPeriod.Enabled = False
    '            ContextMenuStripRightClick.Enabled = False
    '            m_NoLogin = True

    '        End If
    '    End Sub

    'Private btnExportToExcel As New AddInMenuItem("IncomeStatements.Export", "Excel", "Export to Microsoft Excel", True)
    'Private btnPrint As New AddInMenuItem("IncomeStatements.Print", "Print", "Print Document", True)
    'Private btnSaveLayoutzz As New AddInMenuItem("IncomeStatements.SaveLayout", "Layout-Add", "Add New Layout", True)
    'Private btnDeleteLayoutzz As New AddInMenuItem("IncomeStatements.DeleteLayout", "Layout-Delete", "Delete Selected Layout", False)
    'Private btnUpdateLayoutzz As New AddInMenuItem("IncomeStatements.UpdateLayout", "Layout-Edit", "Update Selected Layout", False)
    ''Private btnLoadLayoutzz As New AddInMenuItem("IncomeStatements.LoadLayout", "Layout-Apply", "Load Selected Layout", False)
    'Private m_menuItems_Layouts As New AddInMenuItem("IncomeStatements.Layouts", "Layout", "Select Grid Layout", True)

    'Private m_menuItemsSub_FiscalYears As New AddInMenuItem("IncomeStatements.FiscalYear", "", "Select Fiscal Year", True)
    'Private m_menuItemsSub_FiscalMonths As New AddInMenuItem("IncomeStatements.FiscalMonth", "", "Select Fiscal Period", True)

    'Private btnSegments As New AddInMenuItem("IncomeStatements.Segments", "Segments", "Segments", True)
    'Private sepSegments As AddInMenuItem = AddInMenuItem.CreateSeparator()

    'Private btnDataSourceMode As New AddInMenuItem("IncomeStatements.DataSourceMode", "Source", "Select between Income Statement and Balance Sheet modes.", True)
    'Private lblFiscalPeriod As AddInMenuItem = New AddInMenuItem("IncomeStatements.PLACEHOLDER", "", "", True)

    'Private btnExpandAllRows As AddInMenuItem = New AddInMenuItem("IncomeStatements.ExpandAllRows", "ExpandAll", "Expands all rows in the grid", True)
    'Private btnColapseAllRows As AddInMenuItem = New AddInMenuItem("IncomeStatements.ColapseAllRows", "ColapseAll", "Colapses all rows in the grid", True)

    '    Public WriteOnly Property Database As Meritsoft.GolfRez.Data.Database Implements IApplicationExtenderAddInTypeOne.Database
    '        Set(value As Meritsoft.GolfRez.Data.Database)
    '            db = value
    '            m_oConn = CType(db.ActiveConnection, IDbConnection)

    '            Try

    '                Dim sem As Meritsoft.GolfRez.Data.Semaphore = db.CreateSemaphore("GLOBAL.COMMON.ORGANIZATION.CLUBLOGO")
    '                m_ClubLogo = sem.Value

    '                posSettings = New Business.POSSettings(m_oConn)
    '                m_RetainedEarningsGLAccount = posSettings.RetainedEarningsAccountNumber

    '                m_SegmentsDataSource.Tables.Add(GetGLSegmentsDataSource("One"))
    '                m_SegmentsDataSource.Tables.Add(GetGLSegmentsDataSource("Two"))

    '                m_FiscalPeriodsDT = GetFiscalPeriodsDataSource()

    '                Dim lastPeriodRow As DataRow = Nothing
    '                'lets determine fiscal period we are in, so we can set the initial values to the last fiscal period (since it's complete)
    '                Dim nw As DateTime = DateTime.Now
    '                For Each dr As DataRow In m_FiscalPeriodsDT.Rows

    '                    Dim periodStart As DateTime
    '                    If Not (DateTime.TryParse(dr("period_start_date"), periodStart)) Then
    '                        Continue For
    '                    End If

    '                    Dim periodEnd As DateTime
    '                    If Not (DateTime.TryParse(dr("period_end_date"), periodEnd)) Then
    '                        Continue For
    '                    End If

    '                    If ((nw <= periodEnd) And (nw >= periodStart)) Then

    '                        Dim desc As String = ""

    '                        If (lastPeriodRow Is Nothing) Then
    '                            m_CurrentFiscalPeriod = dr("fiscal_period")
    '                            desc = dr("description").ToString().Trim()
    '                        Else
    '                            m_CurrentFiscalPeriod = lastPeriodRow("fiscal_period")
    '                            desc = lastPeriodRow("description").ToString().Trim()
    '                        End If

    '                        Dim m As String = desc.Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)(0)
    '                        Dim y As String = desc.Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)(1)

    '                        m_menuItemsSub_FiscalMonths.Text = "Month"
    '                        m_menuItemsSub_FiscalYears.Text = "Year"
    '                        lblFiscalPeriod.Text = "Fiscal Period: " & m & " " & y  ' TODO: remove this once the parent menu items can have their text changed at runtime

    '                        Exit For
    '                    End If

    '                    lastPeriodRow = dr
    '                Next

    '                Dim v_years As New List(Of Integer)()
    '                For Each dr As DataRow In m_FiscalPeriodsDT.Rows

    '                    Dim desc As String = dr("description")
    '                    Dim y As Integer = CInt(desc.Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)(1).Trim())

    '                    If Not (v_years.Contains(y)) Then
    '                        v_years.Add(y)
    '                    End If
    '                Next
    '                v_years.Sort()

    '                For Each y As Integer In v_years
    '                    Dim item As New AddInMenuItem("IncomeStatements.FiscalYears." & y.ToString(), "Fiscal Year", y.ToString(), True)
    '                    item.Text = y.ToString()
    '                    item.Tag = y
    '                    m_menuItemsSub_FiscalYears.MenuItems.Add(item)
    '                Next

    '                For Each m As String In New String() {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"}
    '                    Dim item As New AddInMenuItem("IncomeStatements.FiscalMonths." & m, "Fiscal Month", m, True)
    '                    item.Text = m
    '                    item.Tag = m
    '                    m_menuItemsSub_FiscalMonths.MenuItems.Add(item)
    '                Next

    '                m_menuItems_Layouts.Text = "Selected Layout (None)"
    '                m_LayoutsDataSource = GetLayoutsDataSource(Me.Name, Me.ugridFinancialStatements.Name)

    '                btnExportToExcel.Text = "Export"
    '                btnPrint.Text = "Print"
    '                btnSegments.ToolTipText = "SegmentOne: (none) - SegmentTwo: (none)"
    '                btnSegments.Text = "GL Segments:"

    '                btnDataSourceMode.Text = "Source: Income Statement"
    '                btnDataSourceMode.ToolTipText = "Select between Income Statement and Balance Sheet modes."

    '                _menuItems = New AddInMenuItems()
    '                _menuItems.AddRange(AddInMenuItem.CreateLabel("Financial Statements:"),
    '                                    AddInMenuItem.CreateSeparator(),
    '                                    btnPrint,
    '                                    AddInMenuItem.CreateSeparator(),
    '                                    m_menuItems_Layouts,
    '                                    btnSaveLayoutzz,
    '                                    btnDeleteLayoutzz,
    '                                    btnUpdateLayoutzz,
    '                                    AddInMenuItem.CreateSeparator(),
    '                                    btnSegments,
    '                                    sepSegments,
    '                                    lblFiscalPeriod,
    '                                    m_menuItemsSub_FiscalMonths,
    '                                    m_menuItemsSub_FiscalYears,
    '                                    AddInMenuItem.CreateSeparator(),
    '                                    btnDataSourceMode,
    '                                    AddInMenuItem.CreateSeparator(),
    '                                    btnColapseAllRows,
    '                                    btnExpandAllRows)

    '            Catch ex As Exception

    '            End Try
    '        End Set
    '    End Property

    '    Private _menuItems As AddInMenuItems

    '    Public ReadOnly Property MenuItems As AddInMenuItems Implements IApplicationExtenderAddInTypeOne.MenuItems
    '        Get
    '            Return _menuItems
    '        End Get
    '    End Property

    '    Private Function DetermineFiscalPeriod(ByVal v_year As Integer, ByVal v_Month As String) As Integer
    '        For Each dr As DataRow In m_FiscalPeriodsDT.Rows
    '            If (dr("description").ToString().Trim() = v_Month & " " & v_year.ToString()) Then
    '                Return dr("fiscal_period")
    '            End If
    '        Next
    '    End Function

    '    Public Sub MenuItemSelected(menuItem As AddInMenuItem) Implements IApplicationExtenderAddInTypeOne.MenuItemSelected

    '        If (m_NoLogin) Then
    '            Return
    '        End If

    '        If (menuItem.Key.StartsWith("IncomeStatements.FiscalMonths.")) Then

    '            Dim y As String = CInt(lblFiscalPeriod.Text.Replace("Fiscal Period: ", "").Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)(1))
    '            lblFiscalPeriod.Text = "Fiscal Period: " & menuItem.Text & " " & y.ToString()
    '            btnApplyFiscalPeriod_Click(Nothing, Nothing)

    '        ElseIf (menuItem.Key.StartsWith("IncomeStatements.FiscalYears.")) Then

    '            Dim m As String = lblFiscalPeriod.Text.Replace("Fiscal Period: ", "").Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)(0)
    '            lblFiscalPeriod.Text = "Fiscal Period: " & m & " " & menuItem.Text
    '            btnApplyFiscalPeriod_Click(Nothing, Nothing)

    '        Else
    '            Select Case menuItem.Key
    '                Case "IncomeStatements.Export"
    '                    btnExportToExcel_Click(Nothing, Nothing)
    '                Case "IncomeStatements.Print"
    '                    StartPrintingGirdLayout()
    '                Case "IncomeStatements.ApplyFiscalPeriod"
    '                    btnApplyFiscalPeriod_Click(Nothing, Nothing)
    '                Case "IncomeStatements.SaveLayout"
    '                    btnSaveLayout_Click(Nothing, Nothing)
    '                Case "IncomeStatements.DeleteLayout"
    '                    btnDeleteLayout_Click(Nothing, Nothing)
    '                Case "IncomeStatements.UpdateLayout"
    '                    btnUpdateLayout_Click(Nothing, Nothing)
    '                Case "IncomeStatements.ExpandAllRows"
    '                    ugridFinancialStatements.Rows.ExpandAll(True)
    '                Case "IncomeStatements.ColapseAllRows"
    '                    ugridFinancialStatements.Rows.CollapseAll(True)
    '                    ugridFinancialStatements.Rows.ExpandAll(False)
    '                Case "IncomeStatements.DataSourceMode"

    '                    If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then

    '                        m_DataSourceMode = DataSourceMode.BalanceSheet
    '                        btnDataSourceMode.Text = "Source: Balance Sheet"
    '                        btnSegments.Visible = False
    '                        sepSegments.Visible = False
    '                        Me.Name = "Balance Sheet"

    '                    ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then

    '                        m_DataSourceMode = DataSourceMode.IncomeStatement
    '                        btnDataSourceMode.Text = "Source: Income Statement"
    '                        btnSegments.Visible = True
    '                        sepSegments.Visible = True
    '                        Me.Name = "Income Statement"

    '                    End If

    '                    btnApplyFiscalPeriod_Click(Nothing, Nothing)

    '                Case "IncomeStatements.Layouts"

    '                    Dim selectLayout As New InfragristicsControlLayoutSelect(ugridFinancialStatements.Name, Me.Name, m_LayoutsDataSource, m_CurrentLayoutKey)
    '                    If (selectLayout.ShowDialog() = Windows.Forms.DialogResult.OK) Then

    '                        m_menuItems_Layouts.Tag = selectLayout.SelectedRow("layout_key")
    '                        m_menuItems_Layouts.Text = "Selected Layout (" & selectLayout.SelectedRow("description") & ")"
    '                        CheckSecurityAccess()

    '                        btnLoadLayout_Click(Nothing, Nothing)

    '                    End If
    '                    selectLayout.Dispose()

    '                Case "IncomeStatements.Segments"

    '                    Dim segmentsForm As New frmGLSegementsSelect(m_SegmentsDataSource, m_CurrentSegmentOne, m_CurrentSegmentTwo)
    '                    If (segmentsForm.ShowDialog() = Windows.Forms.DialogResult.OK) Then

    '                        Dim segOne As String = "(none)"
    '                        If Not (segmentsForm.SegmentOne = "") Then
    '                            segOne = segmentsForm.SegmentOne
    '                            m_CurrentSegmentOne = segOne
    '                        Else
    '                            m_CurrentSegmentOne = ""
    '                        End If

    '                        Dim segTwo As String = "(none)"
    '                        If Not (segmentsForm.SegmentTwo = "") Then
    '                            segTwo = segmentsForm.SegmentTwo
    '                            m_CurrentSegmentTwo = segTwo
    '                        Else
    '                            m_CurrentSegmentTwo = ""
    '                        End If

    '                        btnSegments.ToolTipText = "SegmentOne: " & segOne & " - SegmentTwo: " & segTwo

    '                        btnApplyGLFilter_Click(Nothing, Nothing)

    '                    End If
    '                    segmentsForm.Dispose()

    '            End Select
    '        End If
    '    End Sub

    '    Public Sub Setup(startUp As Boolean) Implements IApplicationExtenderAddInTypeOne.Setup
    '        If Not startUp Then
    '            MessageBox.Show("The ""TimeCard Manager"" add-in requires no setup.", _
    '                             "Setup Feature Not Required.", _
    '                             MessageBoxButtons.OK, MessageBoxIcon.Information)
    '        End If
    '    End Sub

    '    Public Sub ShowAboutBox() Implements IApplicationExtenderAddInTypeOne.ShowAboutBox

    '    End Sub

    '    Public Function Start() As Form Implements IApplicationExtenderAddInTypeOne.Start
    '        Try
    '            If (sm.RequestAccess("Financial.IncomeStatement")) Then
    '                CheckSecurityAccess()
    '                Return Me
    '            Else
    '                Return Nothing
    '            End If
    '        Catch ex As Exception
    '            Throw New NotImplementedException(ex.Message)
    '        End Try
    '    End Function

    '    Public Sub Terminate(e As ApplicationExtenderTerminateEventArgs) Implements IApplicationExtenderAddInTypeOne.Terminate
    '    End Sub

    '    Private Sub CheckSecurityAccess()

    '        If Not (sm.HasAccess("Financial.IncomeStatement")) Then
    '            Me.Close()
    '        Else
    '            'btnLoadLayoutzz.Enabled = True
    '        End If

    '        If (sm.HasAccess("Financial.IncomeStatement.CreateLayout")) Then
    '            btnSaveLayoutzz.Enabled = True
    '        Else
    '            btnSaveLayoutzz.Enabled = False
    '        End If

    '        If (sm.HasAccess("Financial.IncomeStatement.DeleteLayout")) Then
    '            If (m_menuItems_Layouts.Text.ToLower().Contains("(none)")) Then
    '                btnDeleteLayoutzz.Enabled = False
    '            Else
    '                btnDeleteLayoutzz.Enabled = True
    '            End If
    '        Else
    '            btnDeleteLayoutzz.Enabled = False
    '        End If

    '        If (sm.HasAccess("Financial.IncomeStatement.UpdateLayout")) Then
    '            If (m_menuItems_Layouts.Text.ToLower().Contains("(none)")) Then
    '                btnUpdateLayoutzz.Enabled = False
    '            Else
    '                btnUpdateLayoutzz.Enabled = True
    '            End If
    '        Else
    '            btnUpdateLayoutzz.Enabled = False
    '        End If

    '        If (sm.HasAccess("Financial.IncomeStatement.ExcelExport")) Then
    '            btnExportToExcel.Enabled = True
    '        Else
    '            btnExportToExcel.Enabled = False
    '        End If

    '        If (sm.HasAccess("Financial.IncomeStatement.Print")) Then
    '            btnPrint.Enabled = True
    '        Else
    '            btnPrint.Enabled = False
    '        End If

    '        If (sm.HasAccess("Financial.IncomeStatement.LoadGLReports")) Then
    '            ContextMenuStripRightClick.Enabled = True
    '        Else
    '            ContextMenuStripRightClick.Enabled = False
    '        End If

    '    End Sub


    '    Public ReadOnly Property Features As Feature() Implements ISecuredFeature.Features
    '        Get
    '            Return New Feature() {
    '                New Feature("Financial.IncomeStatement", "Allows the user to generate and view an Income Statement."),
    '                New Feature("Financial.IncomeStatement.CreateLayout", "Allows the user to create a layout for an Income Statement."),
    '                New Feature("Financial.IncomeStatement.DeleteLayout", "Allows the user to delete a layout for an Income Statement."),
    '                New Feature("Financial.IncomeStatement.UpdateLayout", "Allows the user to update a layout for an Income Statement."),
    '                New Feature("Financial.IncomeStatement.ExcelExport", "Allows the user to save the current view and layout of an Income Statement to a Microsoft Excel File."),
    '                New Feature("Financial.IncomeStatement.Print", "Allows the user to print the current view and layout of an Income Statement."),
    '                New Feature("Financial.IncomeStatement.LoadGLReports", "Allows the user to Load GL Reports based on the currently selected row.")
    '            }
    '        End Get
    '    End Property

    '    Public WriteOnly Property SecurityManager As SecurityManager Implements ISecuredFeature.SecurityManager
    '        Set(value As SecurityManager)
    '            sm = value
    '        End Set
    '    End Property

    '#End Region

#Region "Data Access"

    Private Sub OpenDatabaseConnection()
        If Not (m_oConn.State = ConnectionState.Open) Then
            m_oConn.Open()
        End If
    End Sub

    Private Function GetLayoutsDataSource(ByVal v_ModuleName As String, ByVal v_ControlName As String) As DataTable

        m_LayoutsDataSource = New DataTable("Layouts")

        Dim cmd As New SqlCommand("SELECT * FROM InfragisticsControlLayouts WHERE module_name = @ModuleName AND control_name = @ControlName ORDER BY description ", m_oConn)

        cmd.Parameters.Add("@ModuleName", SqlDbType.VarChar)
        cmd.Parameters("@ModuleName").Value = v_ModuleName
        cmd.Parameters.Add("@ControlName", SqlDbType.VarChar)

        If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
            cmd.Parameters("@ControlName").Value = v_ControlName & "_IS"
        ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
            cmd.Parameters("@ControlName").Value = v_ControlName & "_BS"
        End If

        OpenDatabaseConnection()

        Dim adapter As New SqlDataAdapter(cmd)
        adapter.Fill(m_LayoutsDataSource)

        adapter.Dispose()
        cmd.Dispose()
        m_oConn.Close()

        Return m_LayoutsDataSource
    End Function

    Private Sub UpdateLayout(ByVal v_LayoutKey As Integer, ByVal v_Payload As Byte(), ByVal v_segments As String)

        Dim cmd As New SqlCommand("UPDATE InfragisticsControlLayouts SET layout_payload = @PayLoad, segments = @Segments WHERE layout_key = @LayoutKey ", m_oConn)

        cmd.Parameters.Add("@Payload", SqlDbType.VarBinary)
        cmd.Parameters("@PayLoad").Value = v_Payload
        cmd.Parameters.Add("@Segments", SqlDbType.VarChar)
        cmd.Parameters("@Segments").Value = v_segments
        cmd.Parameters.Add("@LayoutKey", SqlDbType.Int)
        cmd.Parameters("@LayoutKey").Value = v_LayoutKey

        OpenDatabaseConnection()

        cmd.ExecuteNonQuery()
        cmd.Dispose()
        m_oConn.Close()

    End Sub

    Private Function AddNewLayout(ByVal v_Payload As Byte(), ByVal v_Description As String, ByVal v_Segments As String) As Integer

        Dim cmd As New SqlCommand("INSERT INTO InfragisticsControlLayouts (layout_payload, description, module_name, control_name, sequence, segments) VALUES (@PayLoad, @Description, @ModuleName, @ControlName, 0, @Segments); SELECT SCOPE_IDENTITY();", m_oConn)

        cmd.Parameters.Add("@Payload", SqlDbType.VarBinary)
        cmd.Parameters("@PayLoad").Value = v_Payload
        cmd.Parameters.Add("@ModuleName", SqlDbType.VarChar)
        cmd.Parameters("@ModuleName").Value = Me.Name
        cmd.Parameters.Add("@ControlName", SqlDbType.VarChar)

        If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
            cmd.Parameters("@ControlName").Value = ugridFinancialStatements.Name & "_IS"
        ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
            cmd.Parameters("@ControlName").Value = ugridFinancialStatements.Name & "_BS"
        End If

        cmd.Parameters.Add("@Description", SqlDbType.VarChar)
        cmd.Parameters("@Description").Value = v_Description
        cmd.Parameters.Add("@Segments", SqlDbType.VarChar)
        cmd.Parameters("@Segments").Value = v_Segments

        OpenDatabaseConnection()

        Dim ret As Decimal = cmd.ExecuteScalar()
        cmd.Dispose()
        m_oConn.Close()

        Return CInt(ret)

    End Function

    Private Sub DeleteLayout(ByVal v_LayoutKey As Integer)

        Dim cmd As New SqlCommand("DELETE FROM InfragisticsControlLayouts WHERE layout_key = @LayoutKey ", m_oConn)

        cmd.Parameters.Add("@LayoutKey", SqlDbType.Int)
        cmd.Parameters("@LayoutKey").Value = v_LayoutKey

        OpenDatabaseConnection()

        cmd.ExecuteNonQuery()
        cmd.Dispose()
        m_oConn.Close()

    End Sub

    Private Function GetGLSegmentsDataSource(ByVal identifier As String) As DataTable

        If Not (identifier = "One") And Not (identifier = "Two") And Not (identifier = "Three") Then
            Throw New Exception("Identifier must be one of these 3 values ('One', 'Two', 'Three')")
        End If

        Dim dt As New DataTable("Segment" & identifier)
        Dim cmd As New SqlCommand("SELECT gl_segment_" & identifier.ToLower() & "_number AS segment FROM gl_accounts GROUP BY gl_segment_" & identifier.ToLower() & "_number ORDER BY gl_segment_" & identifier.ToLower() & "_number", m_oConn)

        OpenDatabaseConnection()

        Dim adap As New SqlDataAdapter(cmd)
        adap.Fill(dt)

        adap.Dispose()
        cmd.Dispose()
        m_oConn.Close()

        Return dt

    End Function

    Private Function GetFiscalPeriodsDataSource() As DataTable

        Dim dt As New DataTable("FiscalPeriods")
        Dim cmd As New SqlCommand("SELECT * FROM fiscal_periods", m_oConn) ' WHERE closed IS NOT NULL

        OpenDatabaseConnection()

        Dim adap As New SqlDataAdapter(cmd)
        adap.Fill(dt)

        adap.Dispose()
        cmd.Dispose()
        m_oConn.Close()

        Return dt

    End Function

    Private Sub BindDataGrid(ByVal v_SegmentOne As String, ByVal v_SegmentTwo As String, ByVal v_SegmentThree As String, ByVal v_FiscalPeriod As Integer)

        Dim v_frmPleaseWait As New frmPleaseWait()
        Try
            v_frmPleaseWait.StartPosition = FormStartPosition.CenterScreen
            v_frmPleaseWait.Show(Me.ParentForm)

            Application.DoEvents()

            'm_CurrentSegmentOne = v_SegmentOne
            'm_CurrentSegmentTwo = v_SegmentTwo
            'm_CurrentSegmentThree = v_SegmentThree

            'ugridFinancialStatements.DataSource = Nothing
            'dSource = New BindingList(Of NodeObject)

            'Dim cmd As New SqlCommand("proc_report_financial_statement", m_oConn)
            'cmd.CommandType = CommandType.StoredProcedure


            'cmd.Parameters.Add("@fiscalperiod", SqlDbType.Int)
            'cmd.Parameters.Add("@StatementType", SqlDbType.Char, 2)
            'cmd.Parameters.Add("@SegmentOne", SqlDbType.VarChar)
            'cmd.Parameters.Add("@SegmentTwo", SqlDbType.VarChar)
            'cmd.Parameters.Add("@SegmentThree", SqlDbType.VarChar)

            'cmd.Parameters("@fiscalperiod").Value = v_FiscalPeriod

            'If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
            '    cmd.Parameters("@StatementType").Value = "IS"
            '    cmd.Parameters("@SegmentOne").Value = v_SegmentOne
            '    cmd.Parameters("@SegmentTwo").Value = v_SegmentTwo
            '    cmd.Parameters("@SegmentThree").Value = v_SegmentThree
            'ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
            '    cmd.Parameters("@StatementType").Value = "BS"
            '    cmd.Parameters("@SegmentOne").Value = ""
            '    cmd.Parameters("@SegmentTwo").Value = ""
            '    cmd.Parameters("@SegmentThree").Value = ""
            'End If

            'OpenDatabaseConnection()




            Dim m_DataSource As New DataSet()
            m_DataSource.ReadXml(Environment.CurrentDirectory & "\Xresults.xml")

            'Dim adapter As New SqlDataAdapter(cmd)
            'adapter.Fill(m_DataSource)

            Dim nRow2 As DataRow = Nothing

            If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
                m_DataSource.Tables("Table").TableName = "Revenue"
                m_DataSource.Tables("Table1").TableName = "Expenses"
                m_DataSource.Tables("Table2").TableName = "Totals"
            ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
                m_DataSource.Tables("Table").TableName = "Assets"
                m_DataSource.Tables("Table1").TableName = "Liabilities"
                m_DataSource.Tables("Table2").TableName = "Equity"

                'Load the 2 values from the 2 last tables (1 value each) as a new row alongside the retianed earnings entry
                m_DataSource.Tables("Table3").TableName = "RetainedEarnings_CurrentBalance"
                m_DataSource.Tables("Table4").TableName = "RetainedEarnings_LYCurrentBalance"
                For Each dr As DataRow In m_DataSource.Tables("Equity").Rows
                    If (dr("AccountNumber") = m_RetainedEarningsGLAccount) Then
                        Dim nRow As DataRow = Nothing

                        'Posted retained earning
                        nRow = m_DataSource.Tables("Equity").NewRow()
                        nRow.ItemArray = dr.ItemArray
                        nRow("Parent") = 999999
                        nRow("CHILD") = 0
                        nRow("Hierarchy") = dr("Hierarchy") & " | Posted"
                        nRow("Level") = dr("Level") + 1
                        nRow("Description") = "Posted"
                        nRow("CurrentBalance") = dr("CurrentBalance")
                        nRow("LYCurrentBalance") = dr("LYCurrentBalance")
                        m_DataSource.Tables("Equity").Rows.Add(nRow)

                        'unposted retained earnings
                        nRow2 = m_DataSource.Tables("Equity").NewRow()
                        nRow2.ItemArray = dr.ItemArray
                        nRow2("Parent") = 999999
                        nRow2("CHILD") = 0
                        nRow2("Hierarchy") = dr("Hierarchy") & " | Unposted"
                        nRow2("Level") = dr("Level") + 1
                        nRow2("Description") = "Unposted"
                        nRow2("CurrentBalance") = m_DataSource.Tables("RetainedEarnings_CurrentBalance").Rows(0)(0)
                        nRow2("LYCurrentBalance") = m_DataSource.Tables("RetainedEarnings_LYCurrentBalance").Rows(0)(0)
                        m_DataSource.Tables("Equity").Rows.Add(nRow2)

                        'Retained Earnings parent row
                        dr("CurrentBalance") = CDec(nRow("CurrentBalance")) + CDec(nRow2("CurrentBalance"))
                        dr("LYCurrentBalance") = CDec(nRow("LYCurrentBalance")) + CDec(nRow2("LYCurrentBalance"))
                        dr("CHILD") = 999999
                        dr("AccountNumber") = "///"

                        m_DataSource.Tables("Equity").AcceptChanges()
                        Exit For

                    End If
                Next

            End If

            'adapter.Dispose()
            'cmd.Dispose()
            'm_oConn.Close()

            For Each TAB As DataTable In m_DataSource.Tables
                TAB.Columns.Add("UniqueRowID", GetType(String))
                For Each row As DataRow In TAB.Rows
                    row("UniqueRowID") = Guid.NewGuid().ToString()
                Next
            Next
            m_DataSource.AcceptChanges()

            If (m_DataSource.Tables(0).Rows.Count > 0) Then

                If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then

                    ' convert the datatables to Bindinglist objects (much faster for a hierarchial grid)
                    Dim nodes1 As BindingList(Of NodeObject) = BuildNodes(m_DataSource.Tables("Revenue"), -1)
                    Dim nodes2 As BindingList(Of NodeObject) = BuildNodes(m_DataSource.Tables("Expenses"), -1)

                    dSource.Add(nodes1(0))
                    dSource.Add(nodes2(0))

                ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then

                    UpdateDataSetValues(m_DataSource, nRow2)

                    'reverse positive and negatives in these 2 tables (Assets is correct)
                    For Each TAB As DataTable In m_DataSource.Tables
                        If (TAB.TableName = "Liabilities") Or (TAB.TableName = "Equity") Then
                            For Each ROW As DataRow In TAB.Rows
                                ROW("CurrentBalance") = ROW("CurrentBalance") * -1
                                ROW("LYCurrentBalance") = ROW("LYCurrentBalance") * -1
                            Next
                        End If
                    Next
                    m_DataSource.AcceptChanges()

                    ' convert the datatables to Bindinglist objects (much faster for a hierarchial grid)
                    Dim nodes1 As BindingList(Of NodeObject) = BuildNodes(m_DataSource.Tables("Assets"), -1)
                    Dim nodes2 As BindingList(Of NodeObject) = BuildNodes(m_DataSource.Tables("Liabilities"), -1)
                    Dim nodes3 As BindingList(Of NodeObject) = BuildNodes(m_DataSource.Tables("Equity"), -1)

                    dSource.Add(nodes1(0))
                    dSource.Add(nodes2(0))
                    dSource.Add(nodes3(0))

                End If

                ugridFinancialStatements.DisplayLayout.MaxBandDepth = 10
                ugridFinancialStatements.DataSource = dSource

            Else
                MessageBox.Show("No Data")
            End If

        Catch ex As Exception

        Finally
            v_frmPleaseWait.Close()
            v_frmPleaseWait.Dispose()
        End Try

    End Sub

    Private Sub UpdateDataSetValues(ByVal v_DS As DataSet, ByVal v_UnpostedRow As DataRow)

        Try
            ' only used when m_DataSourceMode = DataSourceMode.BalanceSheet
            For Each tab As DataTable In v_DS.Tables
                If (tab.TableName = "Equity") Then

                    Dim maxCHILD As Integer = 0 ' get the max level so we can work up the hirerarchy
                    For Each row As DataRow In tab.Rows
                        If (maxCHILD < row("Level") And Not (row("UniqueRowID") = v_UnpostedRow("UniqueRowID"))) Then
                            maxCHILD = row("Level")
                        End If
                    Next

                    For i As Integer = maxCHILD To 1 Step -1
                        'get the unique parent ids
                        Dim parentids As New List(Of Integer)()
                        For Each row As DataRow In tab.Select("[Level] = '" & i.ToString() & "'")
                            If Not (parentids.Contains(row("Parent"))) Then
                                parentids.Add(row("Parent"))
                            End If
                        Next

                        'loop over the parentids, and tally up the children
                        For Each pID As Integer In parentids

                            Dim cBal As Decimal = Decimal.Zero
                            Dim lyBal As Decimal = Decimal.Zero

                            For Each row As DataRow In tab.Select("[Parent] = '" & pID & "'")
                                cBal += row("CurrentBalance")
                                lyBal += row("LYCurrentBalance")
                            Next

                            'Update the row
                            Dim rowToModify As DataRow = tab.Select("[CHILD] = '" & pID & "'")(0)

                            'If ((tab.TableName = "Equity") And (v_UnpostedRow("Level") - 1 = i)) Then
                            '    cBal += v_UnpostedRow("CurrentBalance")
                            '    lyBal += v_UnpostedRow("LYCurrentBalance")
                            'End If

                            rowToModify("CurrentBalance") = cBal
                            rowToModify("LYCurrentBalance") = lyBal

                        Next
                    Next
                End If
            Next

            v_DS.AcceptChanges()

        Catch ex As Exception

        End Try

    End Sub

#End Region

#Region "grid event handlers"

    Private Sub UltraGrid1_InitializeLayout(sender As Object, e As InitializeLayoutEventArgs) Handles ugridFinancialStatements.InitializeLayout

        ugridFinancialStatements.SuspendLayout()

        isWorking = True
        e.Layout.Override.AllowColSizing = AllowColSizing.Synchronized
        e.Layout.ColumnChooserEnabled = DefaultableBoolean.True
        e.Layout.ScrollStyle = ScrollStyle.Immediate
        e.Layout.Scrollbars = UltraWinGrid.Scrollbars.Automatic
        e.Layout.PriorityScrolling = True
        e.Layout.Override.ExpansionIndicator = ShowExpansionIndicator.CheckOnDisplay
        e.Layout.Override.GroupByRowExpansionStyle = GroupByRowExpansionStyle.ExpansionIndicator

        For Each band As UltraGridBand In e.Layout.Bands

            If (band.Key = e.Layout.Bands(0).Key) Then
                band.Layout.Override.RowSelectors = DefaultableBoolean.True
                band.Layout.Grid.Rows(0).Expanded = True
                band.Layout.Grid.Rows(1).Expanded = True
                If (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
                    band.Layout.Grid.Rows(2).Expanded = True
                End If
            Else
                band.ColHeadersVisible = False
            End If

            band.Columns("Parent").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("EmptyRowCell").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("CHILD").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("AccountNumber").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("Hierarchy").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("Level").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("newDesc").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("ParentDescription").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
            band.Columns("UniqueRowID").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True

            band.Columns("Parent").Hidden = True
            band.Columns("EmptyRowCell").Hidden = True
            band.Columns("CHILD").Hidden = True
            band.Columns("AccountNumber").Hidden = True
            band.Columns("Hierarchy").Hidden = True
            band.Columns("Level").Hidden = True
            band.Columns("newDesc").Hidden = True
            band.Columns("ParentDescription").Hidden = True
            band.Columns("UniqueRowID").Hidden = True

            band.Columns("Parent").Width = 0
            band.Columns("EmptyRowCell").Width = 0
            band.Columns("CHILD").Width = 0
            band.Columns("AccountNumber").Width = 0
            band.Columns("Hierarchy").Width = 0
            band.Columns("Level").Width = 0
            band.Columns("newDesc").Width = 0
            band.Columns("ParentDescription").Width = 0
            band.Columns("UniqueRowID").Width = 0

            If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then

                band.Columns("CurrentBalance").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("LYCurrentBalance").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("CurrentBalance").Hidden = True
                band.Columns("LYCurrentBalance").Hidden = True
                band.Columns("CurrentBalance").Width = 0
                band.Columns("LYCurrentBalance").Width = 0

                band.Columns("MonthActual").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("MonthActual").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("MonthBudget").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("MonthBudget").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("MonthLastYear").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("MonthLastYear").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("MonthVarianceDollar").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("MonthVarianceDollar").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("YearActual").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("YearActual").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("YearBudget").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("YearBudget").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("YearLastYear").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("YearLastYear").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("YearVarianceDollar").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("YearVarianceDollar").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("UnspentBudget").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("UnspentBudget").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("AnnualBudget").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("AnnualBudget").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("YearVariancePercent").Format = "0%;(0)%;'0'"
                band.Columns("YearVariancePercent").CellAppearance.TextHAlign = HAlign.Center

                band.Columns("MonthVariancePercent").Format = "0%;(0)%;'0'"
                band.Columns("MonthVariancePercent").CellAppearance.TextHAlign = HAlign.Center

                band.Columns("Parent").Header.Caption = "Parent ID"
                band.Columns("CHILD").Header.Caption = "Child ID"
                band.Columns("newDesc").Header.Caption = "New Description"
                band.Columns("ParentDescription").Header.Caption = "Parent Description"
                band.Columns("UniqueRowID").Header.Caption = "Unique Row ID"
                band.Columns("MonthActual").Header.Caption = "Month Actual"
                band.Columns("MonthBudget").Header.Caption = "Month Budget"
                band.Columns("MonthLastYear").Header.Caption = "Month Last Year"
                band.Columns("MonthVarianceDollar").Header.Caption = "Month Var $"
                band.Columns("MonthVariancePercent").Header.Caption = "Month Var %"
                band.Columns("YearActual").Header.Caption = "Year Actual"
                band.Columns("YearBudget").Header.Caption = "Year Budget"
                band.Columns("YearLastYear").Header.Caption = "Year Last Year"
                band.Columns("YearVarianceDollar").Header.Caption = "Year Var $"
                band.Columns("YearVariancePercent").Header.Caption = "Year Var %"
                band.Columns("UnspentBudget").Header.Caption = "Unspent Budget"
                band.Columns("AnnualBudget").Header.Caption = "Annual Budget"

            ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then

                band.Columns("MonthActual").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("MonthBudget").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("MonthLastYear").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("MonthVarianceDollar").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("MonthVariancePercent").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("YearActual").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("YearBudget").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("YearLastYear").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("YearVarianceDollar").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("YearVariancePercent").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("UnspentBudget").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True
                band.Columns("AnnualBudget").ExcludeFromColumnChooser = ExcludeFromColumnChooser.True

                band.Columns("MonthActual").Hidden = True
                band.Columns("MonthBudget").Hidden = True
                band.Columns("MonthLastYear").Hidden = True
                band.Columns("MonthVarianceDollar").Hidden = True
                band.Columns("MonthVariancePercent").Hidden = True
                band.Columns("YearActual").Hidden = True
                band.Columns("YearBudget").Hidden = True
                band.Columns("YearLastYear").Hidden = True
                band.Columns("YearVarianceDollar").Hidden = True
                band.Columns("YearVariancePercent").Hidden = True
                band.Columns("UnspentBudget").Hidden = True
                band.Columns("AnnualBudget").Hidden = True

                band.Columns("MonthActual").Width = 0
                band.Columns("MonthBudget").Width = 0
                band.Columns("MonthLastYear").Width = 0
                band.Columns("MonthVarianceDollar").Width = 0
                band.Columns("MonthVariancePercent").Width = 0
                band.Columns("YearActual").Width = 0
                band.Columns("YearBudget").Width = 0
                band.Columns("YearLastYear").Width = 0
                band.Columns("YearVarianceDollar").Width = 0
                band.Columns("YearVariancePercent").Width = 0
                band.Columns("UnspentBudget").Width = 0
                band.Columns("AnnualBudget").Width = 0

                band.Columns("CurrentBalance").Header.Caption = "Current Balance"
                band.Columns("LYCurrentBalance").Header.Caption = "Last Year Balance"

                band.Columns("CurrentBalance").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("CurrentBalance").CellAppearance.TextHAlign = HAlign.Right

                band.Columns("LYCurrentBalance").Format = "$#,##0.00;$(#,##0.00);'0.00'"
                band.Columns("LYCurrentBalance").CellAppearance.TextHAlign = HAlign.Right

            End If

        Next

        SetSummaries(e.Layout)

        isWorking = False

        ugridFinancialStatements.ResumeLayout()

    End Sub

    Private Sub SetSummaries(ByVal v_Layout As UltraGridLayout)


        For Each band As UltraGridBand In v_Layout.Bands
            Try
                'Dim bmp As Bitmap = Meritsoft.Utilities.Helper.GetResourceBitmap(GetType(BuzSoftware.Images.ImageManager), "BuzSoftware.Images.Graphics.SummaryAmount.png")

                band.Layout.Override.SummaryFooterCaptionVisible = False
                band.Layout.Override.SummaryValueAppearance.TextHAlign = HAlign.Right
                band.SummaryFooterCaption = ""

                If (m_DataSourceMode = DataSourceMode.BalanceSheet) Then

                    If (band.Key = v_Layout.Bands(0).Key) Then

                        Dim summaryDesc As SummarySettings = band.Summaries.Add("Description", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("Description"), SummaryPosition.UseSummaryPositionColumn, band.Columns("Description"))
                        summaryDesc.DisplayFormat = "{0}"

                        Dim summary As SummarySettings = band.Summaries.Add("CurrentBalance", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("CurrentBalance"), SummaryPosition.UseSummaryPositionColumn, band.Columns("CurrentBalance"))
                        'summary.Appearance.ImageBackground = bmp
                        summary.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched
                        summary.DisplayFormat = "{0}"

                        Dim summary1 As SummarySettings = band.Summaries.Add("LYCurrentBalance", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("LYCurrentBalance"), SummaryPosition.UseSummaryPositionColumn, band.Columns("LYCurrentBalance"))
                        'summary1.Appearance.ImageBackground = bmp
                        summary1.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched
                        summary1.DisplayFormat = "{0}"

                    Else

                        Dim summaryDesc As SummarySettings = band.Summaries.Add("Description", SummaryType.Custom, New ChildBandTotalsSummary(False), band.Columns("Description"), SummaryPosition.UseSummaryPositionColumn, band.Columns("Description"))
                        summaryDesc.DisplayFormat = "{0}"

                        Dim summary As SummarySettings = band.Summaries.Add("CurrentBalance", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("CurrentBalance"), SummaryPosition.UseSummaryPositionColumn, band.Columns("CurrentBalance"))
                        'summary.Appearance.ImageBackground = bmp
                        summary.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched
                        summary.DisplayFormat = "{0}"

                        Dim summary1 As SummarySettings = band.Summaries.Add("LYCurrentBalance", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("LYCurrentBalance"), SummaryPosition.UseSummaryPositionColumn, band.Columns("LYCurrentBalance"))
                        'summary1.Appearance.ImageBackground = bmp
                        summary1.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched
                        summary1.DisplayFormat = "{0}"

                    End If


                ElseIf (m_DataSourceMode = DataSourceMode.IncomeStatement) Then

                    If (band.Key = v_Layout.Bands(0).Key) Then

                        Dim summaryDesc As SummarySettings = band.Summaries.Add("Description", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("Description"), SummaryPosition.UseSummaryPositionColumn, band.Columns("Description"))
                        summaryDesc.DisplayFormat = "{0}"

                        Dim summary As SummarySettings = band.Summaries.Add("MonthBudget", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("MonthBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthBudget"))
                        summary.DisplayFormat = "{0}"
                        'summary.Appearance.ImageBackground = bmp
                        summary.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary1 As SummarySettings = band.Summaries.Add("MonthActual", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("MonthActual"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthActual"))
                        summary1.DisplayFormat = "{0}"
                        'summary1.Appearance.ImageBackground = bmp
                        summary1.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary2 As SummarySettings = band.Summaries.Add("MonthLastYear", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("MonthLastYear"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthLastYear"))
                        summary2.DisplayFormat = "{0}"
                        'summary2.Appearance.ImageBackground = bmp
                        summary2.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary3 As SummarySettings = band.Summaries.Add("MonthVarianceDollar", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("MonthVarianceDollar"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthVarianceDollar"))
                        summary3.DisplayFormat = "{0}"
                        'summary3.Appearance.ImageBackground = bmp
                        summary3.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary4 As SummarySettings = band.Summaries.Add("YearActual", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("YearActual"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearActual"))
                        summary4.DisplayFormat = "{0}"
                        'summary4.Appearance.ImageBackground = bmp
                        summary4.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary5 As SummarySettings = band.Summaries.Add("YearBudget", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("YearBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearBudget"))
                        summary5.DisplayFormat = "{0}"
                        'summary5.Appearance.ImageBackground = bmp
                        summary5.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary6 As SummarySettings = band.Summaries.Add("YearLastYear", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("YearLastYear"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearLastYear"))
                        summary6.DisplayFormat = "{0}"
                        'summary6.Appearance.ImageBackground = bmp
                        summary6.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary7 As SummarySettings = band.Summaries.Add("YearVarianceDollar", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("YearVarianceDollar"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearVarianceDollar"))
                        summary7.DisplayFormat = "{0}"
                        'summary7.Appearance.ImageBackground = bmp
                        summary7.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary8 As SummarySettings = band.Summaries.Add("UnspentBudget", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("UnspentBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("UnspentBudget"))
                        summary8.DisplayFormat = "{0}"
                        'summary8.Appearance.ImageBackground = bmp
                        summary8.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary9 As SummarySettings = band.Summaries.Add("AnnualBudget", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("AnnualBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("AnnualBudget"))
                        summary9.DisplayFormat = "{0}"
                        'summary9.Appearance.ImageBackground = bmp
                        summary9.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary10 As SummarySettings = band.Summaries.Add("YearVariancePercent", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("YearVariancePercent"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearVariancePercent"))
                        summary10.DisplayFormat = "{0}"
                        'summary10.Appearance.ImageBackground = bmp
                        summary10.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary11 As SummarySettings = band.Summaries.Add("MonthVariancePercent", SummaryType.Custom, New BandZeroTotalsSummary(m_DataSourceMode), band.Columns("MonthVariancePercent"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthVariancePercent"))
                        summary11.DisplayFormat = "{0}"
                        'summary11.Appearance.ImageBackground = bmp
                        summary11.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                    Else

                        Dim summaryDesc As SummarySettings = band.Summaries.Add("Description", SummaryType.Custom, New ChildBandTotalsSummary(False), band.Columns("Description"), SummaryPosition.UseSummaryPositionColumn, band.Columns("Description"))
                        summaryDesc.DisplayFormat = "{0}"

                        Dim summary As SummarySettings = band.Summaries.Add("MonthBudget", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("MonthBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthBudget"))
                        summary.DisplayFormat = "{0}"
                        'summary.Appearance.ImageBackground = bmp
                        summary.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary1 As SummarySettings = band.Summaries.Add("MonthActual", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("MonthActual"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthActual"))
                        summary1.DisplayFormat = "{0}"
                        'summary1.Appearance.ImageBackground = bmp
                        summary1.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary2 As SummarySettings = band.Summaries.Add("MonthLastYear", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("MonthLastYear"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthLastYear"))
                        summary2.DisplayFormat = "{0}"
                        'summary2.Appearance.ImageBackground = bmp
                        summary2.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary3 As SummarySettings = band.Summaries.Add("MonthVarianceDollar", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("MonthVarianceDollar"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthVarianceDollar"))
                        summary3.DisplayFormat = "{0}"
                        'summary3.Appearance.ImageBackground = bmp
                        summary3.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary4 As SummarySettings = band.Summaries.Add("YearActual", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("YearActual"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearActual"))
                        summary4.DisplayFormat = "{0}"
                        'summary4.Appearance.ImageBackground = bmp
                        summary4.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary5 As SummarySettings = band.Summaries.Add("YearBudget", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("YearBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearBudget"))
                        summary5.DisplayFormat = "{0}"
                        'summary5.Appearance.ImageBackground = bmp
                        summary5.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary6 As SummarySettings = band.Summaries.Add("YearLastYear", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("YearLastYear"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearLastYear"))
                        summary6.DisplayFormat = "{0}"
                        ' summary6.Appearance.ImageBackground = bmp
                        summary6.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary7 As SummarySettings = band.Summaries.Add("YearVarianceDollar", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("YearVarianceDollar"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearVarianceDollar"))
                        summary7.DisplayFormat = "{0}"
                        ' summary7.Appearance.ImageBackground = bmp
                        summary7.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary8 As SummarySettings = band.Summaries.Add("UnspentBudget", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("UnspentBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("UnspentBudget"))
                        summary8.DisplayFormat = "{0}"
                        '  summary8.Appearance.ImageBackground = bmp
                        summary8.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary9 As SummarySettings = band.Summaries.Add("AnnualBudget", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("AnnualBudget"), SummaryPosition.UseSummaryPositionColumn, band.Columns("AnnualBudget"))
                        summary9.DisplayFormat = "{0}"
                        '  summary9.Appearance.ImageBackground = bmp
                        summary9.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary10 As SummarySettings = band.Summaries.Add("YearVariancePercent", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("YearVariancePercent"), SummaryPosition.UseSummaryPositionColumn, band.Columns("YearVariancePercent"))
                        summary10.DisplayFormat = "{0}"
                        ' summary10.Appearance.ImageBackground = bmp
                        summary10.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                        Dim summary11 As SummarySettings = band.Summaries.Add("MonthVariancePercent", SummaryType.Custom, New ChildBandTotalsSummary(True), band.Columns("MonthVariancePercent"), SummaryPosition.UseSummaryPositionColumn, band.Columns("MonthVariancePercent"))
                        summary11.DisplayFormat = "{0}"
                        ' summary11.Appearance.ImageBackground = bmp
                        summary11.Appearance.ImageBackgroundStyle = ImageBackgroundStyle.Stretched

                    End If
                End If
            Catch ex As Exception
                Dim bah As String = ""
            End Try
        Next


    End Sub

    Private Sub ugridFinancialStatements_BeforeColumnChooserDisplayed(sender As Object, e As BeforeColumnChooserDisplayedEventArgs) Handles ugridFinancialStatements.BeforeColumnChooserDisplayed

        e.Dialog.ColumnChooserControl.MultipleBandSupport = MultipleBandSupport.SingleBandOnly
        e.Dialog.ColumnChooserControl.Style = ColumnChooserStyle.AllColumnsWithCheckBoxes
        e.Dialog.ColumnChooserControl.ColumnDisplayOrder = ColumnDisplayOrder.SameAsGrid
        e.Dialog.ColumnChooserControl.CurrentBand = ugridFinancialStatements.DisplayLayout.Bands(0)
        e.Dialog.ColumnChooserControl.DisplayLayout.Grid.Rows.FilterRow.Hidden = True

    End Sub

    Private Sub ugridFinancialStatements_BeforeColPosChanged(sender As System.Object, e As Infragistics.Win.UltraWinGrid.BeforeColPosChangedEventArgs) Handles ugridFinancialStatements.BeforeColPosChanged
        If Not (isWorking) Then
            isWorking = True

            If (e.PosChanged = PosChanged.HiddenStateChanged) Then

                For Each band As UltraGridBand In ugridFinancialStatements.DisplayLayout.Bands
                    If Not (band.Key = e.ColumnHeaders(0).Band.Key) Then
                        For Each col As UltraGridColumn In band.Columns
                            If (col.Key = e.ColumnHeaders(0).Column.Key) Then
                                col.Hidden = Not e.ColumnHeaders(0).Column.Hidden
                            End If
                        Next
                    End If
                Next

            ElseIf (e.PosChanged = PosChanged.Moved) Then

                For Each band As UltraGridBand In ugridFinancialStatements.DisplayLayout.Bands
                    If Not (band.Key = e.ColumnHeaders(0).Band.Key) Then

                        band.Columns(e.ColumnHeaders(0).Column.Key).Header.VisiblePosition = e.ColumnHeaders(0).VisiblePosition

                    End If
                Next

            End If
            isWorking = False
        End If

    End Sub

    Private Sub UltraGrid1_BeforeCellActivate(sender As Object, e As CancelableCellEventArgs) Handles ugridFinancialStatements.BeforeCellActivate
        'only allow full row select
        e.Cancel = True
        e.Cell.Row.Selected = True
    End Sub

    Private Sub ugridFinancialStatements_BeforeRowActivate(sender As System.Object, e As Infragistics.Win.UltraWinGrid.RowEventArgs) Handles ugridFinancialStatements.BeforeRowActivate

        Try

            ugridFinancialStatements.Selected.Rows.Clear()

            If (e.Row.Cells("AccountNumber").Value = "///") Then
                For Each cell As UltraGridCell In e.Row.Cells.All
                    If (cell.Appearance.ForeColor = Color.White) Then
                        cell.SelectedAppearance.ForeColor = Color.DodgerBlue
                        cell.ActiveAppearance.ForeColor = Color.DodgerBlue
                        cell.SelectedAppearance.BackColor = Color.DodgerBlue
                        cell.ActiveAppearance.BackColor = Color.DodgerBlue
                    Else
                        cell.SelectedAppearance.ForeColor = Color.Empty
                        cell.ActiveAppearance.ForeColor = Color.Empty
                        cell.SelectedAppearance.BackColor = Color.Empty
                        cell.ActiveAppearance.BackColor = Color.Empty
                    End If
                Next
            End If

        Catch ex As Exception
            Dim bah As String = ""
        End Try

    End Sub

    Private Sub ugridFinancialStatements_BeforeRowExpanded(sender As System.Object, e As Infragistics.Win.UltraWinGrid.CancelableRowEventArgs) Handles ugridFinancialStatements.BeforeRowExpanded

        Try



            If (e.Row.Cells("AccountNumber").Value = "///") Then
                For Each cell As UltraGridCell In e.Row.Cells.All
                    If (cell.Column.Key = "Description") Then
                        cell.Appearance.BackColor = Color.MintCream
                    Else
                        cell.Appearance.BackColor = Color.White
                        cell.Appearance.ForeColor = Color.White
                        cell.Appearance.BorderColor = Color.White
                        cell.SelectedAppearance.ForeColor = Color.DodgerBlue
                        cell.ActiveAppearance.ForeColor = Color.DodgerBlue
                        cell.SelectedAppearance.BackColor = Color.DodgerBlue
                        cell.ActiveAppearance.BackColor = Color.DodgerBlue
                    End If
                Next

                If (e.Row.HasParent()) Then
                    For Each row As UltraGridRow In e.Row.ParentRow.Band.Layout.Rows.All
                        If (row.IsSummaryRow) Then
                            Dim sumRow As UltraGridSummaryRow = CType(e.Row, UltraGridSummaryRow)
                        End If
                    Next
                End If

                'Dim expandRow As Infragistics.Win.UltraWinGrid.UltraGridGroupByRow = CType(e.Row, UltraGridGroupByRow)
            End If

        Catch ex As Exception
            Dim bah As String = ""
        End Try

    End Sub

    Private Sub ugridFinancialStatements_BeforeRowCollapsed(sender As System.Object, e As Infragistics.Win.UltraWinGrid.CancelableRowEventArgs) Handles ugridFinancialStatements.BeforeRowCollapsed


        Try


            If (e.Row.Cells("AccountNumber").Value = "///") Then
                For Each cell As UltraGridCell In e.Row.Cells.All
                    If (cell.Column.Key = "Description") Then
                        cell.Appearance.BackColor = Color.MintCream
                    Else
                        cell.Appearance.BackColor = Color.Empty
                        cell.Appearance.ForeColor = Color.Empty
                        cell.Appearance.BorderColor = Color.Empty
                        cell.SelectedAppearance.ForeColor = Color.Empty
                        cell.ActiveAppearance.ForeColor = Color.Empty
                        cell.SelectedAppearance.BackColor = Color.Empty
                        cell.ActiveAppearance.BackColor = Color.Empty
                    End If
                Next
            End If
        Catch ex As Exception
            Dim bah As String = ""
        End Try
    End Sub

#End Region

#Region "internal helper classes"

    Private Class ChildBandTotalsSummary
        Implements ICustomSummaryCalculator

        Private totals As Decimal = 0
        Private returnValue As Object = Nothing
        Private m_DoMath As Boolean = False

        Public Sub New(ByVal v_DoMath As Boolean)
            m_DoMath = v_DoMath
        End Sub

        Private Sub BeginCustomSummary(ByVal summarySettings As SummarySettings, ByVal rows As RowsCollection) Implements ICustomSummaryCalculator.BeginCustomSummary
            Try
                Me.totals = 0
                returnValue = ""
            Catch ex As Exception
                Dim bah As String = ""
            End Try

        End Sub

        Private Sub AggregateCustomSummary(ByVal summarySettings As SummarySettings, ByVal row As UltraGridRow) Implements ICustomSummaryCalculator.AggregateCustomSummary
            Try
                If (m_DoMath) Then
                    Me.totals += row.Cells(summarySettings.SourceColumn.Key).Value

                End If
            Catch ex As Exception
                Dim bah As String = ""
            End Try

        End Sub

        Private Function EndCustomSummary(ByVal summarySettings As SummarySettings, ByVal rows As RowsCollection) As Object Implements ICustomSummaryCalculator.EndCustomSummary

            Try



                If (m_DoMath) Then

                    If (summarySettings.SourceColumn.Key = "MonthVariancePercent") Then

                        Dim VarDollar As Decimal = Decimal.Zero
                        Dim Budget As Decimal = Decimal.Zero

                        For Each row As UltraGridRow In rows.All
                            VarDollar += row.Cells("MonthVarianceDollar").Value
                            Budget += row.Cells("MonthBudget").Value
                        Next

                        Dim varPerc As String = ""
                        If Not (Budget = 0) Then
                            varPerc = Math.Round(((VarDollar / Budget) * 100))
                        Else
                            varPerc = 0
                        End If

                        If (varPerc < 0) Then 'negative color
                            summarySettings.Appearance.BackColor = Color.PaleVioletRed
                        Else
                            summarySettings.Appearance.BackColor = Color.AliceBlue
                        End If
                        summarySettings.Appearance.TextHAlign = HAlign.Center

                        If (varPerc = 0) Then ' zero
                            'do nothing zero is what we want
                        ElseIf (varPerc < 0) Then ' negative 
                            varPerc = "(" & (varPerc * -1) & ")%"
                        ElseIf (varPerc > 0) Then ' positive
                            varPerc = varPerc & "%"
                        End If

                        Return varPerc

                    ElseIf (summarySettings.SourceColumn.Key = "YearVariancePercent") Then

                        Dim VarDollar As Decimal = Decimal.Zero
                        Dim Budget As Decimal = Decimal.Zero

                        For Each row As UltraGridRow In rows.All
                            VarDollar += row.Cells("YearVarianceDollar").Value
                            Budget += row.Cells("YearBudget").Value
                        Next

                        Dim varPerc As String = ""
                        If Not (Budget = 0) Then
                            varPerc = Math.Round(((VarDollar / Budget) * 100))
                        Else
                            varPerc = 0
                        End If

                        If (varPerc < 0) Then 'negative color
                            summarySettings.Appearance.BackColor = Color.PaleVioletRed
                        Else
                            summarySettings.Appearance.BackColor = Color.AliceBlue
                        End If
                        summarySettings.Appearance.TextHAlign = HAlign.Center

                        If (varPerc = 0) Then ' zero
                            'do nothing zero is what we want
                        ElseIf (varPerc < 0) Then ' negative 
                            varPerc = "(" & (varPerc * -1) & ")%"
                        ElseIf (varPerc > 0) Then ' positive
                            varPerc = varPerc & "%"
                        End If

                        Return varPerc

                    Else

                        summarySettings.Appearance.TextHAlign = HAlign.Right
                        summarySettings.Appearance.BackColor = Color.AliceBlue

                        If (Me.totals < 0) Then 'negative color
                            summarySettings.Appearance.BackColor = Color.PaleVioletRed
                        Else
                            summarySettings.Appearance.BackColor = Color.AliceBlue
                        End If

                        Return Me.totals.ToString("$#,##0.00;$(#,##0.00);'0.00'") ' currency format

                    End If
                Else
                    summarySettings.Appearance.TextHAlign = HAlign.Right
                    summarySettings.Appearance.BackColor = Color.AliceBlue
                    Return "Total " & rows(0).ParentRow.Cells("Description").Value
                End If

            Catch ex As Exception
                Dim bah As String = ""
            End Try

            Return ""

        End Function

    End Class

    Private Class BandZeroTotalsSummary
        Implements ICustomSummaryCalculator

        Private totals As Decimal = 0
        Private returnValue As Object = Nothing
        Private o_DataSourceMode As DataSourceMode

        Public Sub New(ByVal v_DataSourceMode As DataSourceMode)
            o_DataSourceMode = v_DataSourceMode
        End Sub

        Private Sub BeginCustomSummary(ByVal summarySettings As SummarySettings, ByVal rows As RowsCollection) Implements ICustomSummaryCalculator.BeginCustomSummary
            Me.totals = 0
            returnValue = ""
        End Sub

        Private Sub AggregateCustomSummary(ByVal summarySettings As SummarySettings, ByVal row As UltraGridRow) Implements ICustomSummaryCalculator.AggregateCustomSummary
        End Sub

        Private Function EndCustomSummary(ByVal summarySettings As SummarySettings, ByVal rows As RowsCollection) As Object Implements ICustomSummaryCalculator.EndCustomSummary

            If (o_DataSourceMode = DataSourceMode.IncomeStatement) Then

                If (summarySettings.SourceColumn.Key = "Description") Then

                    summarySettings.Appearance.TextHAlign = HAlign.Right
                    summarySettings.Appearance.BackColor = Color.AliceBlue

                    Return "Net Profit/(Loss)"

                ElseIf (summarySettings.SourceColumn.Key.Contains("VariancePercent")) Then

                    summarySettings.Appearance.TextHAlign = HAlign.Center

                    Dim varPerc As String = ""

                    If (summarySettings.SourceColumn.Key = "YearVariancePercent") Then

                        Dim YrVarDollar_rev As Decimal = rows(0).Cells("YearVarianceDollar").Value
                        Dim YrBudget_rev As Decimal = rows(0).Cells("YearBudget").Value

                        Dim YrVarDollar_exp As Decimal = rows(1).Cells("YearVarianceDollar").Value
                        Dim YrBudget_exp As Decimal = rows(1).Cells("YearBudget").Value

                        Dim YrVarDollar_tot As Decimal = YrVarDollar_rev - YrVarDollar_exp
                        Dim YrBudget_tot As Decimal = YrBudget_rev - YrBudget_exp

                        If Not (YrBudget_tot = 0) Then
                            varPerc = Math.Round(((YrVarDollar_tot / YrBudget_tot) * 100))
                        Else
                            varPerc = 0
                        End If

                    ElseIf (summarySettings.SourceColumn.Key = "MonthVariancePercent") Then

                        Dim MtVarDollar_rev As Decimal = rows(0).Cells("MonthVarianceDollar").Value
                        Dim MtBudget_rev As Decimal = rows(0).Cells("MonthBudget").Value

                        Dim MtVarDollar_exp As Decimal = rows(1).Cells("MonthVarianceDollar").Value
                        Dim MtBudget_exp As Decimal = rows(1).Cells("MonthBudget").Value

                        Dim MtVarDollar_tot As Decimal = MtVarDollar_rev - MtVarDollar_exp
                        Dim MtBudget_tot As Decimal = MtBudget_rev - MtBudget_exp

                        If Not (MtBudget_tot = 0) Then
                            varPerc = Math.Round(((MtVarDollar_tot / MtBudget_tot) * 100))
                        Else
                            varPerc = 0
                        End If

                    End If

                    If (varPerc < 0) Then 'negative color
                        summarySettings.Appearance.BackColor = Color.PaleVioletRed
                    Else
                        summarySettings.Appearance.BackColor = Color.AliceBlue
                    End If

                    If (varPerc = 0) Then ' zero
                        'do nothing zero is what we want
                    ElseIf (varPerc < 0) Then ' negative 
                        varPerc = "(" & (varPerc * -1) & ")%"
                    ElseIf (varPerc > 0) Then ' positive
                        varPerc = varPerc & "%"
                    End If

                    Return varPerc

                Else

                    summarySettings.Appearance.TextHAlign = HAlign.Right
                    summarySettings.Appearance.BackColor = Color.AliceBlue

                    Dim rev As Decimal = rows(0).Cells(summarySettings.SourceColumn.Key).Value  ' revenue
                    Dim exp As Decimal = rows(1).Cells(summarySettings.SourceColumn.Key).Value  ' expenses

                    Dim t As Decimal = CDec((rev - exp)) ' different

                    If (t < 0) Then 'negative color
                        summarySettings.Appearance.BackColor = Color.PaleVioletRed
                    Else
                        summarySettings.Appearance.BackColor = Color.AliceBlue
                    End If

                    Return t.ToString("$#,##0.00;$(#,##0.00);'0.00'") ' currency format

                End If

            ElseIf (o_DataSourceMode = DataSourceMode.BalanceSheet) Then

                If (summarySettings.SourceColumn.Key = "Description") Then

                    summarySettings.Appearance.TextHAlign = HAlign.Right
                    summarySettings.Appearance.BackColor = Color.AliceBlue
                    Return "Liabilities and Equity"

                Else

                    summarySettings.Appearance.TextHAlign = HAlign.Right
                    summarySettings.Appearance.BackColor = Color.AliceBlue

                    Dim liabilities As Decimal = rows(1).Cells(summarySettings.SourceColumn.Key).Value  ' revenue
                    Dim equity As Decimal = rows(2).Cells(summarySettings.SourceColumn.Key).Value  ' expenses

                    Dim t As Decimal = CDec((liabilities + equity)) ' different

                    If (t < 0) Then 'negative color
                        summarySettings.Appearance.BackColor = Color.PaleVioletRed
                    Else
                        summarySettings.Appearance.BackColor = Color.AliceBlue
                    End If
                    Return t.ToString("$#,##0.00;$(#,##0.00);'0.00'") ' currency format

                End If
            Else
                Return Nothing
            End If

        End Function

    End Class

    Private Class NodeObject

        Public Sub New(ByVal v_Row As DataRow, ByVal v_Children As BindingList(Of NodeObject))

            ParseDataRow(v_Row)
            m_Children = v_Children

        End Sub

        Public Sub New()

            ' set the default values here, should only be called when the ultragrid tries to add a new row
            Me.m_CHILD = 0
            Me.m_Description = ""
            Me.m_AccountNumber = "na"
            Me.m_Hierarchy = 0
            Me.m_Level = 0
            Me.m_MonthActual = 0
            Me.m_MonthBudget = 0
            Me.m_MonthLastYear = 0
            Me.m_MonthVarianceDollar = 0
            Me.m_MonthVariancePercent = 0
            Me.m_newDesc = 0
            Me.m_Parent = 0
            Me.m_ParentDescription = 0
            Me.m_UnspentBudget = 0
            Me.m_AnnualBudget = 0
            Me.m_YearActual = 0
            Me.m_YearBudget = 0
            Me.m_YearLastYear = 0
            Me.m_YearVarianceDollar = 0
            Me.m_YearVariancePercent = 0
            Me.m_UniqueRowID = Guid.NewGuid().ToString()
            Me.m_CurrentBalance = 0
            Me.m_LYCurrentBalance = 0

        End Sub

        Private Sub ParseDataRow(ByVal v_Row As DataRow)

            Me.m_AnnualBudget = v_Row("AnnualBudget")
            Me.m_CHILD = v_Row("CHILD")

            If (v_Row("AccountNumber") = "///") Then
                Me.m_Description = v_Row("Description").ToString().Trim()
            Else
                Me.m_Description = v_Row("Description").ToString().Trim() & " (" & v_Row("AccountNumber").ToString().Trim() & ")"
            End If

            Me.m_AccountNumber = v_Row("AccountNumber").ToString().Trim()
            Me.m_Hierarchy = v_Row("Hierarchy").ToString().Trim()
            Me.m_Level = v_Row("Level")
            Me.m_MonthActual = v_Row("MonthActual")
            Me.m_MonthBudget = v_Row("MonthBudget")
            Me.m_MonthLastYear = v_Row("MonthLastYear")
            Me.m_MonthVarianceDollar = v_Row("MonthVarianceDollar")
            Me.m_MonthVariancePercent = v_Row("MonthVariancePercent")
            Me.m_newDesc = v_Row("newDesc").ToString().Trim()
            Me.m_Parent = v_Row("Parent")
            Me.m_ParentDescription = v_Row("ParentDesription").ToString().Trim()
            Me.m_UnspentBudget = v_Row("UnspentBudget")
            Me.m_YearActual = v_Row("YearActual")
            Me.m_YearBudget = v_Row("YearBudget")
            Me.m_YearLastYear = v_Row("YearLastYear")
            Me.m_YearVarianceDollar = v_Row("YearVarianceDollar")
            Me.m_YearVariancePercent = v_Row("YearVariancePercent")
            Me.m_UniqueRowID = v_Row("UniqueRowID")
            Me.m_CurrentBalance = v_Row("CurrentBalance")
            Me.m_LYCurrentBalance = v_Row("LYCurrentBalance")

        End Sub

        Private m_Children As BindingList(Of NodeObject)
        Public Property Children() As BindingList(Of NodeObject)
            Get
                Return m_Children
            End Get
            Set(ByVal value As BindingList(Of NodeObject))
                m_Children = value
            End Set
        End Property

        Private m_UniqueRowID As String
        Public Property UniqueRowID() As String
            Get
                Return m_UniqueRowID
            End Get
            Set(ByVal value As String)
                m_UniqueRowID = value
            End Set
        End Property

        Private m_EmptyRowCell As String = "EmptyRowCell"
        Public Property EmptyRowCell() As String
            Get
                Return m_EmptyRowCell
            End Get
            Set(ByVal value As String)
                m_EmptyRowCell = value
            End Set
        End Property

#Region "datacolumn return data properties"

        Private m_Parent As Integer
        Public Property Parent() As Integer
            Get
                Return m_Parent
            End Get
            Set(ByVal value As Integer)
                m_Parent = value
            End Set
        End Property

        Private m_AccountNumber As String
        Public Property AccountNumber() As String
            Get
                Return m_AccountNumber
            End Get
            Set(ByVal value As String)
                m_AccountNumber = value
            End Set
        End Property

        Private m_CHILD As Integer
        Public Property CHILD() As Integer
            Get
                Return m_CHILD
            End Get
            Set(ByVal value As Integer)
                m_CHILD = value
            End Set
        End Property

        Private m_Description As String
        Public Property Description() As String
            Get
                Return m_Description
            End Get
            Set(ByVal value As String)
                m_Description = value
            End Set
        End Property

        Private m_Level As Integer
        Public Property Level() As Integer
            Get
                Return m_Level
            End Get
            Set(ByVal value As Integer)
                m_Level = value
            End Set
        End Property

        Private m_Hierarchy As String
        Public Property Hierarchy() As String
            Get
                Return m_Hierarchy
            End Get
            Set(ByVal value As String)
                m_Hierarchy = value
            End Set
        End Property

        Private m_MonthActual As Decimal
        Public Property MonthActual() As Decimal
            Get
                Return m_MonthActual
            End Get
            Set(ByVal value As Decimal)
                m_MonthActual = value
            End Set
        End Property

        Private m_MonthBudget As Decimal
        Public Property MonthBudget() As Decimal
            Get
                Return m_MonthBudget
            End Get
            Set(ByVal value As Decimal)
                m_MonthBudget = value
            End Set
        End Property

        Private m_MonthLastYear As Decimal
        Public Property MonthLastYear() As Decimal
            Get
                Return m_MonthLastYear
            End Get
            Set(ByVal value As Decimal)
                m_MonthLastYear = value
            End Set
        End Property

        Private m_MonthVarianceDollar As Decimal
        Public Property MonthVarianceDollar() As Decimal
            Get
                Return m_MonthVarianceDollar
            End Get
            Set(ByVal value As Decimal)
                m_MonthVarianceDollar = value
            End Set
        End Property

        Private m_MonthVariancePercent As Decimal
        Public Property MonthVariancePercent() As Decimal
            Get
                Return m_MonthVariancePercent
            End Get
            Set(ByVal value As Decimal)
                m_MonthVariancePercent = value
            End Set
        End Property

        Private m_YearActual As Decimal
        Public Property YearActual() As Decimal
            Get
                Return m_YearActual
            End Get
            Set(ByVal value As Decimal)
                m_YearActual = value
            End Set
        End Property

        Private m_YearBudget As Decimal
        Public Property YearBudget() As Decimal
            Get
                Return m_YearBudget
            End Get
            Set(ByVal value As Decimal)
                m_YearBudget = value
            End Set
        End Property

        Private m_YearLastYear As Decimal
        Public Property YearLastYear() As Decimal
            Get
                Return m_YearLastYear
            End Get
            Set(ByVal value As Decimal)
                m_YearLastYear = value
            End Set
        End Property

        Private m_YearVarianceDollar As Decimal
        Public Property YearVarianceDollar() As Decimal
            Get
                Return m_YearVarianceDollar
            End Get
            Set(ByVal value As Decimal)
                m_YearVarianceDollar = value
            End Set
        End Property

        Private m_YearVariancePercent As Decimal
        Public Property YearVariancePercent() As Decimal
            Get
                Return m_YearVariancePercent
            End Get
            Set(ByVal value As Decimal)
                m_YearVariancePercent = value
            End Set
        End Property

        Private m_UnspentBudget As Decimal
        Public Property UnspentBudget() As Decimal
            Get
                Return m_UnspentBudget
            End Get
            Set(ByVal value As Decimal)
                m_UnspentBudget = value
            End Set
        End Property

        Private m_AnnualBudget As Decimal
        Public Property AnnualBudget() As Decimal
            Get
                Return m_AnnualBudget
            End Get
            Set(ByVal value As Decimal)
                m_AnnualBudget = value
            End Set
        End Property

        Private m_newDesc As String
        Public Property newDesc() As String
            Get
                Return m_newDesc
            End Get
            Set(ByVal value As String)
                m_newDesc = value
            End Set
        End Property

        Private m_ParentDescription As String
        Public Property ParentDescription() As String
            Get
                Return m_ParentDescription
            End Get
            Set(ByVal value As String)
                m_ParentDescription = value
            End Set
        End Property

        Private m_CurrentBalance As Decimal
        Public Property CurrentBalance() As Decimal
            Get
                Return m_CurrentBalance
            End Get
            Set(ByVal value As Decimal)
                m_CurrentBalance = value
            End Set
        End Property

        Private m_LYCurrentBalance As Decimal
        Public Property LYCurrentBalance() As Decimal
            Get
                Return m_LYCurrentBalance
            End Get
            Set(ByVal value As Decimal)
                m_LYCurrentBalance = value
            End Set
        End Property

#End Region

    End Class

    Public Class ColumnPositionObject
        Implements IComparable(Of ColumnPositionObject)

        Private m_Width As Integer
        Public Property Width() As Integer
            Get
                Return m_Width
            End Get
            Set(ByVal value As Integer)
                m_Width = value
            End Set
        End Property

        Private m_VisiblePosition As Integer
        Public Property VisiblePosition() As Integer
            Get
                Return m_VisiblePosition
            End Get
            Set(ByVal value As Integer)
                m_VisiblePosition = value
            End Set
        End Property

        Private m_ColumnName As String
        Public Property ColumnName() As String
            Get
                Return m_ColumnName
            End Get
            Set(ByVal value As String)
                m_ColumnName = value
            End Set
        End Property

        Public Sub New(ByVal v_VisiblePosition As Integer, ByVal v_ColumnName As String)
            m_VisiblePosition = v_VisiblePosition
            m_ColumnName = v_ColumnName
        End Sub

        Public Function CompareTo(ByVal other As ColumnPositionObject) As Integer Implements IComparable(Of ColumnPositionObject).CompareTo
            Return Me.VisiblePosition.CompareTo(other.VisiblePosition)
        End Function

    End Class

#End Region

#Region "helpers"

    Private Function BuildNodes(ByVal v_DT As DataTable, ByVal parentID As Integer) As BindingList(Of NodeObject)

        Dim nodes As BindingList(Of NodeObject) = Nothing
        Dim rowsAry() As DataRow = v_DT.Select("[Parent] = '" & parentID & "'")

        If (rowsAry.Length > 0) Then
            nodes = New BindingList(Of NodeObject)
        End If

        For Each dr As DataRow In rowsAry
            If (dr("Parent") = parentID) Then
                nodes.Add(New NodeObject(dr, BuildNodes(v_DT, dr("CHILD"))))
            End If
        Next

        Return nodes

    End Function

    Private Function UltragridLayoutToBytes() As Byte()

        Dim payload() As Byte
        Using Stream As New MemoryStream()
            ugridFinancialStatements.DisplayLayout.Save(Stream, PropertyCategories.All)
            payload = Stream.ToArray()
        End Using
        Return payload

    End Function

    Private Function ParseSegmentString(ByVal segmentsRaw As String) As KeyValuePair(Of String(), String())

        Dim both() As String = segmentsRaw.Split(New String() {";"}, StringSplitOptions.RemoveEmptyEntries)

        Dim s0() As String = both(0).Split(New String() {":"}, StringSplitOptions.RemoveEmptyEntries)
        Dim s1() As String = both(1).Split(New String() {":"}, StringSplitOptions.RemoveEmptyEntries)

        Dim segOnes As New List(Of String)()
        If (s0.Length > 1) Then
            For Each st As String In s0(1).Split(New String() {","}, StringSplitOptions.RemoveEmptyEntries)
                segOnes.Add(st)
            Next
        End If

        Dim segTwos As New List(Of String)()
        If (s1.Length > 1) Then
            For Each st As String In s1(1).Split(New String() {","}, StringSplitOptions.RemoveEmptyEntries)
                segTwos.Add(st)
            Next
        End If

        Dim kvp As New KeyValuePair(Of String(), String())(segOnes.ToArray(), segTwos.ToArray())

        Return kvp

    End Function

    Private Function DetermineHierarchyLevel(ByVal band As UltraGridBand) As Integer

        Dim hierarchyLevel As Integer = 1
        Dim enumerat As IEnumerable = band.GetRowEnumerator(GridRowType.DataRow)
        Dim en As IEnumerator = enumerat.GetEnumerator()
        en.MoveNext()
        Dim obj As Object = en.Current
        If Not (obj Is Nothing) Then
            hierarchyLevel = CType(obj, UltraGridRow).Cells("Level").Value
        End If
        Return hierarchyLevel

    End Function

    Private Function GenerateSegmentsData(ByVal segmentString() As String) As String

        Dim ret As String = ""
        For i As Integer = 0 To segmentString.Length - 1
            ret &= "s" & i & ":" & segmentString(i) & ";"
        Next
        Return ret

    End Function

    Private Function GetSegmentArray(ByVal identifier As String) As String

        'If Not (identifier = "One") And Not (identifier = "Two") And Not (identifier = "Three") Then
        '    Throw New Exception("Identifier must be one of these 3 values ('One', 'Two', 'Three')")
        'End If

        ''Dim btnText As String = btnSegments.ToolTipText
        'Dim spt() As String = btnText.Split(New String() {" - "}, StringSplitOptions.RemoveEmptyEntries)

        'If (identifier = "One") Then
        '    Dim segOne As String = spt(0).Replace("SegmentOne: ", "")
        '    If (segOne = "(none)") Then
        '        Return ""
        '    Else
        '        Return segOne
        '    End If
        'End If

        'If (identifier = "Two") Then
        '    Dim segTwo As String = spt(1).Replace("SegmentTwo: ", "")
        '    If (segTwo = "(none)") Then
        '        Return ""
        '    Else
        '        Return segTwo
        '    End If
        'End If

        Return ""
    End Function

    Private Sub LogEvent(ByVal v_LogType As String, ByVal v_pairs As Dictionary(Of String, String))

        'Dim logger As Meritsoft.POS.Logging.Logger = Meritsoft.POS.Logging.Logger.Instance(m_oConn)
        'Dim typ As Meritsoft.POS.Logging.LogEventType = logger.GetEventType(v_LogType)
        'logger.LogEvent(typ, sm.CurrentUser.UserName, Environment.UserName, v_pairs)

    End Sub

#End Region

#Region "control event handlers"

    'Private Sub btnSaveLayout_Click(sender As Object, e As EventArgs)

    '    Try
    '        Dim frmNewName As New InfragristicsControlLayoutName(m_LayoutsDataSource)
    '        If (frmNewName.ShowDialog() = Windows.Forms.DialogResult.OK) Then

    '            Dim payload() As Byte = UltragridLayoutToBytes()

    '            Dim segments As String = GenerateSegmentsData(New String() {m_CurrentSegmentOne, m_CurrentSegmentTwo})
    '            m_CurrentLayoutKey = AddNewLayout(payload, frmNewName.NewName, segments)

    '            Dim nDr As DataRow = m_LayoutsDataSource.NewRow()
    '            nDr("layout_key") = m_CurrentLayoutKey
    '            nDr("description") = frmNewName.NewName
    '            nDr("module_name") = Me.Name
    '            nDr("control_name") = ugridFinancialStatements.Name
    '            nDr("sequence") = 0
    '            nDr("layout_payload") = payload
    '            nDr("segments") = segments
    '            m_LayoutsDataSource.Rows.Add(nDr)
    '            m_LayoutsDataSource.AcceptChanges()

    '            m_menuItems_Layouts.Tag = m_CurrentLayoutKey
    '            m_menuItems_Layouts.Text = "Selected Layout (" & frmNewName.NewName & ")"

    '            Dim pairs As New Dictionary(Of String, String)

    '            If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
    '                pairs.Add("Statement Source", "Income Statement")
    '            ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
    '                pairs.Add("Statement Source", "Balance Sheet")
    '            End If

    '            pairs.Add("Layout ID", m_CurrentLayoutKey.ToString())

    '            LogEvent("IncomeStatement_LayoutCreated", pairs)

    '        End If
    '        frmNewName.Dispose()

    '    Catch ex As Exception

    '    End Try
    'End Sub

    'Private Sub btnLoadLayout_Click(sender As Object, e As EventArgs)

    '    Dim v_frmPleaseWait As New frmPleaseWait()

    '    Try

    '        v_frmPleaseWait.StartPosition = FormStartPosition.CenterScreen
    '        v_frmPleaseWait.Show(Me.ParentForm)

    '        Application.DoEvents()

    '        btnApplyGLFilter_Click(Nothing, Nothing)
    '        m_IsInitialLoad = True

    '        If Not (m_menuItems_Layouts.Tag = 0) Then

    '            Dim selRow As DataRow = m_LayoutsDataSource.Select("layout_key = '" & m_menuItems_Layouts.Tag & "'")(0)
    '            Dim payload() As Byte = selRow("layout_payload")
    '            Dim segment As String = selRow("segments")

    '            Dim Stream As New MemoryStream(payload)
    '            Stream.Seek(0, SeekOrigin.Begin)
    '            ugridFinancialStatements.DisplayLayout.Load(Stream, PropertyCategories.All)

    '            Application.DoEvents()

    '            Dim kvp As KeyValuePair(Of String(), String()) = ParseSegmentString(segment)
    '            Dim segment1 As String = ""
    '            Dim segment2 As String = ""
    '            For Each st As String In kvp.Key
    '                segment1 &= st & ","
    '            Next
    '            If (segment1.Contains(",")) Then
    '                segment1 = segment1.Remove(segment1.LastIndexOf(","))
    '            End If

    '            m_CurrentSegmentOne = segment1

    '            If (segment1 = "") Then
    '                segment1 = "(none)"
    '            End If

    '            For Each st As String In kvp.Value
    '                segment2 &= st & ","
    '            Next
    '            If (segment2.Contains(",")) Then
    '                segment2 = segment2.Remove(segment2.LastIndexOf(","))
    '            End If

    '            m_CurrentSegmentTwo = segment2

    '            If (segment2 = "") Then
    '                segment2 = "(none)"
    '            End If

    '            Dim btnText As String = "SegmentOne: " & segment1 & " - SegmentTwo: " & segment2
    '            btnSegments.ToolTipText = btnText

    '            Application.DoEvents()

    '            'syncronize column widths, positions, and hidden state as a batch action
    '            For Each band As UltraGridBand In ugridFinancialStatements.DisplayLayout.Bands

    '                If (band.Key = ugridFinancialStatements.DisplayLayout.Bands(0).Key) Then
    '                    Continue For
    '                End If

    '                If (band.Layout.Rows.VisibleRowCount > 0) Then
    '                    Application.DoEvents()
    '                End If

    '                For Each col As UltraGridColumn In band.Columns
    '                    For Each colObj As UltraGridColumn In ugridFinancialStatements.DisplayLayout.Bands(0).Columns

    '                        If (col.Key = colObj.Key) Then
    '                            col.Hidden = colObj.Hidden
    '                            col.Header.VisiblePosition = colObj.Header.VisiblePosition
    '                            'col.Width = colObj.Width
    '                            Exit For
    '                        End If

    '                    Next
    '                Next
    '            Next

    '        End If

    '        SetSummaries(ugridFinancialStatements.DisplayLayout)

    '        Application.DoEvents()

    '    Catch ex As Exception

    '    Finally
    '        m_IsInitialLoad = False

    '        v_frmPleaseWait.Close()
    '        v_frmPleaseWait.Dispose()
    '    End Try

    'End Sub

    'Private Sub btnUpdateLayout_Click(sender As Object, e As EventArgs)

    '    Try
    '        Dim drKey As Integer = m_menuItems_Layouts.Tag

    '        Dim segments As String = GenerateSegmentsData(New String() {m_CurrentSegmentOne, m_CurrentSegmentTwo})
    '        Dim payload() As Byte = UltragridLayoutToBytes()
    '        UpdateLayout(drKey, payload, segments)

    '        Dim row As DataRow = m_LayoutsDataSource.Select("layout_key = '" & drKey & "'")(0)
    '        row("layout_payload") = payload
    '        row("segments") = segments
    '        m_LayoutsDataSource.AcceptChanges()

    '        m_CurrentLayoutKey = drKey

    '        Dim pairs As New Dictionary(Of String, String)

    '        If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
    '            pairs.Add("Statement Source", "Income Statement")
    '        ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
    '            pairs.Add("Statement Source", "Balance Sheet")
    '        End If

    '        pairs.Add("Layout ID", drKey.ToString())

    '        LogEvent("IncomeStatement_LayoutUpdated", pairs)

    '    Catch ex As Exception

    '    End Try

    'End Sub

    'Private Sub btnDeleteLayout_Click(sender As Object, e As EventArgs)

    '    DeleteLayout(m_menuItems_Layouts.Tag)
    '    m_LayoutsDataSource.Select("layout_key = '" & m_menuItems_Layouts.Tag & "'")(0).Delete()
    '    m_LayoutsDataSource.AcceptChanges()

    '    Dim pairs As New Dictionary(Of String, String)

    '    If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
    '        pairs.Add("Statement Source", "Income Statement")
    '    ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
    '        pairs.Add("Statement Source", "Balance Sheet")
    '    End If

    '    pairs.Add("Layout ID", m_menuItems_Layouts.Tag.ToString())

    '    LogEvent("IncomeStatement_LayoutDeleted", pairs)

    'End Sub

    Private Sub btnApplyGLFilter_Click(sender As Object, e As EventArgs)
        Try
            BindDataGrid(GetSegmentArray("One"), GetSegmentArray("Two"), "", m_CurrentFiscalPeriod)
        Catch ex As Exception

        End Try
    End Sub

    'Private Sub btnApplyFiscalPeriod_Click(sender As System.Object, e As System.EventArgs)

    '    m_menuItems_Layouts.Text = "Selected Layout (None)"
    '    m_menuItems_Layouts.Tag = 0
    '    m_LayoutsDataSource = GetLayoutsDataSource(Me.Name, Me.ugridFinancialStatements.Name)
    '    m_CurrentLayoutKey = 0


    '    Dim m As String = lblFiscalPeriod.Text.Replace("Fiscal Period: ", "").Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)(0)
    '    Dim y As String = CInt(lblFiscalPeriod.Text.Replace("Fiscal Period: ", "").Split(New String() {" "}, StringSplitOptions.RemoveEmptyEntries)(1))

    '    m_CurrentFiscalPeriod = DetermineFiscalPeriod(y, m)

    '    btnApplyGLFilter_Click(Nothing, Nothing)

    'End Sub

    Private Sub ugridFinancialStatements_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles ugridFinancialStatements.MouseDown

        ContextMenuStripRightClick.Hide()
        If (e.Button = Windows.Forms.MouseButtons.Right) Then

            Dim pt As Point = ugridFinancialStatements.PointToScreen(e.Location)
            Dim element As UIElement = CType(sender, UltraGrid).DisplayLayout.UIElement.ElementFromPoint(e.Location)
            Dim cell As UltraGridCell = CType(element.GetContext(GetType(UltraGridCell)), UltraGridCell)

            If Not cell Is Nothing Then
                Dim row As UltraGridRow = cell.Row
                'ugridFinancialStatements.Selected.Rows.Clear()
                row.Activate()
                If Not (row.Cells("AccountNumber").Value = "///") Then
                    RightClickRow = row
                    ContextMenuStripRightClick.Show(pt)
                End If
            End If
        End If

    End Sub

    'Private Sub menuGLTransactionsDetailed_Click(sender As System.Object, e As System.EventArgs) Handles menuGLTransactionsDetailed.Click

    '    Try
    '        Dim fiscalRow As DataRow = m_FiscalPeriodsDT.Select("fiscal_period = '" & m_CurrentFiscalPeriod.ToString() & "'")(0)

    '        Dim tab As New DataTable()
    '        tab.Columns.Add("keyid")
    '        tab.Columns.Add("desc")

    '        Dim r1 As DataRow = tab.NewRow()
    '        r1("keyid") = "%"
    '        r1("desc") = "All Sources"
    '        tab.Rows.Add(r1)

    '        Dim r2 As DataRow = tab.NewRow()
    '        r2("keyid") = "AP"
    '        r2("desc") = "Accounts Payable"
    '        tab.Rows.Add(r2)

    '        Dim r3 As DataRow = tab.NewRow()
    '        r3("keyid") = "AR"
    '        r3("desc") = "Accounts Receivable"
    '        tab.Rows.Add(r3)

    '        Dim r4 As DataRow = tab.NewRow()
    '        r4("keyid") = "CH"
    '        r4("desc") = "Cheque Module"
    '        tab.Rows.Add(r4)

    '        Dim r5 As DataRow = tab.NewRow()
    '        r5("keyid") = "GL"
    '        r5("desc") = "General Ledger"
    '        tab.Rows.Add(r5)

    '        Dim r6 As DataRow = tab.NewRow()
    '        r6("keyid") = "RE"
    '        r6("desc") = "POS"
    '        tab.Rows.Add(r6)

    '        Dim r7 As DataRow = tab.NewRow()
    '        r7("keyid") = "PO"
    '        r7("desc") = "Purchase Orders"
    '        tab.Rows.Add(r7)

    '        Dim sel As New InfragristicsControlLayoutSelect(tab)
    '        sel.Text = "Select Source"

    '        If (sel.ShowDialog() = Windows.Forms.DialogResult.OK) Then

    '            m_frmReport = New frmReportManager()
    '            m_frmReport.ShowGLTransactionDetailed(DateTime.Parse(fiscalRow("period_start_date")), DateTime.Parse(fiscalRow("period_end_date")), RightClickRow.Cells("AccountNumber").Value, sel.SelectedRow("keyid"))

    '            Dim pairs As New Dictionary(Of String, String)

    '            If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
    '                pairs.Add("Statement Source", "Income Statement")
    '            ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
    '                pairs.Add("Statement Source", "Balance Sheet")
    '            End If

    '            pairs.Add("Fiscal Period ID", m_CurrentFiscalPeriod.ToString())
    '            pairs.Add("Fiscal Period", lblFiscalPeriod.Text.Replace("Fiscal Period:", "").Trim())
    '            pairs.Add("Layout ID", m_CurrentLayoutKey.ToString())
    '            pairs.Add("Source", sel.SelectedRow("desc").ToString())
    '            pairs.Add("SourceID", sel.SelectedRow("keyid").ToString())
    '            pairs.Add("Account Number", RightClickRow.Cells("AccountNumber").Value)

    '            LogEvent("IncomeStatement_GLTransactionsDetailedLoaded", pairs)

    '        End If
    '        sel.Dispose()

    '    Catch ex As Exception
    '        MessageBox.Show(ex.Message)
    '    End Try

    'End Sub

    'Private Sub menuGLTransactionsSummary_Click(sender As System.Object, e As System.EventArgs) Handles menuGLTransactionsSummary.Click

    '    Try
    '        Dim fiscalRow As DataRow = m_FiscalPeriodsDT.Select("fiscal_period = '" & m_CurrentFiscalPeriod.ToString() & "'")(0)

    '        Dim objBOStockReports As New MMM.BusinessLogicLayer.BOStockReports()
    '        Dim m_DataGL As Business.GLAccounts = objBOStockReports.GetGLAccount()

    '        Dim m_dsGLAccounts As DataSet = m_DataGL.GLAccountList("000", System.DateTime.Today)
    '        Dim m_dtGLAccounts As DataTable = m_dsGLAccounts.Tables(0)

    '        Dim m_strGLAccountSQL(3) As System.Text.StringBuilder
    '        m_strGLAccountSQL(0) = New System.Text.StringBuilder()
    '        m_strGLAccountSQL(0).Append(m_dtGLAccounts.Select("GLAccountNumberFull = '" & RightClickRow.Cells("AccountNumber").Value & "'")(0)("gl_account_id").ToString())
    '        m_strGLAccountSQL(1) = New System.Text.StringBuilder()
    '        m_strGLAccountSQL(2) = New System.Text.StringBuilder()
    '        m_strGLAccountSQL(3) = New System.Text.StringBuilder()

    '        m_frmReport = New frmReportManager()
    '        m_frmReport.ShowGLAccountTransactions(DateTime.Parse(fiscalRow("period_start_date")), DateTime.Parse(fiscalRow("period_end_date")), m_strGLAccountSQL)

    '        Dim pairs As New Dictionary(Of String, String)

    '        If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
    '            pairs.Add("Statement Source", "Income Statement")
    '        ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
    '            pairs.Add("Statement Source", "Balance Sheet")
    '        End If

    '        pairs.Add("Fiscal Period ID", m_CurrentFiscalPeriod.ToString())
    '        pairs.Add("Fiscal Period", lblFiscalPeriod.Text.Replace("Fiscal Period:", "").Trim())
    '        pairs.Add("Layout ID", m_CurrentLayoutKey.ToString())
    '        pairs.Add("Account Number", RightClickRow.Cells("AccountNumber").Value)

    '        LogEvent("IncomeStatement_GLTransactionsSummaryLoaded", pairs)

    '    Catch ex As Exception
    '        MessageBox.Show(ex.Message)
    '    End Try

    'End Sub

#End Region

#Region "Excel Export"

    Private Sub btnExportToExcel_Click(sender As Object, e As EventArgs)
        Dim saveFile As New SaveFileDialog()
        saveFile.Filter = "Excel File|*.xls"
        If (saveFile.ShowDialog() = Windows.Forms.DialogResult.OK) Then

            Dim workbook As New Infragistics.Excel.Workbook()
            Dim worksheet As Infragistics.Excel.Worksheet = workbook.Worksheets.Add(m_DataSourceMode.ToString())

            Dim rIdx As Integer = 1

            'worksheet.Rows(rIdx).Cells(2).Value = posSettings.Name
            'rIdx += 1

            If (m_DataSourceMode = DataSourceMode.BalanceSheet) Then

                worksheet.Rows(rIdx).Cells(2).Value = "Balance Sheet"
                rIdx += 1
            ElseIf (m_DataSourceMode = DataSourceMode.IncomeStatement) Then

                worksheet.Rows(rIdx).Cells(2).Value = "Income Statement"
                rIdx += 1
                'If Not (m_menuItems_Layouts.Text.Contains("(None)")) Then

                '    Dim ly As String = m_menuItems_Layouts.Text.Remove(m_menuItems_Layouts.Text.LastIndexOf(")")).Replace("Selected Layout (", "")

                '    worksheet.Rows(rIdx).Cells(2).Value = ly
                '    rIdx += 1
                'End If
            End If

            'worksheet.Rows(rIdx).Cells(2).Value = lblFiscalPeriod.Text
            'rIdx += 1
            worksheet.Rows(rIdx).Cells(2).Value = DateTime.Now.ToString()
            rIdx += 2

            'UltraGridExcelExporter1.DefaultWorkbookPaletteMode = Infragistics.Excel.WorkbookPaletteMode.StandardPalette
            'UltraGridExcelExporter1.ExportFormulas = False
            'UltraGridExcelExporter1.BandSpacing = BandSpacing.None
            'UltraGridExcelExporter1.Export(ugridFinancialStatements, workbook, rIdx, 0)

            Dim rowsCount As Integer = 0
            Dim groupByRowsCount As Integer = 0
            m_FlatVisibleRowsCollection = New List(Of UltraGridRow)
            ' Call the helper method which is a recursive implmentation for traversing rows.
            Me.getFlatVisibleRowsCollection(Me.ugridFinancialStatements.Rows, rowsCount, groupByRowsCount)


            Dim visibleCells As New List(Of String)()
            For Each cel As UltraGridCell In m_FlatVisibleRowsCollection(0).Cells.All
                If Not (cel.Column.Hidden) Then
                    Dim pos As String = ""
                    If (cel.Column.Header.VisiblePosition.ToString().Length = 1) Then
                        pos = "0" & cel.Column.Header.VisiblePosition.ToString()
                    Else
                        pos = cel.Column.Header.VisiblePosition.ToString()
                    End If
                    visibleCells.Add(pos & "__" & cel.Column.Key)
                End If
            Next

            visibleCells.Sort()

            For Each row As UltraGridRow In m_FlatVisibleRowsCollection
                Dim i As Integer = 0
                For Each cel As String In visibleCells
                    Dim p As Integer = cel.Split(New String() {"__"}, StringSplitOptions.RemoveEmptyEntries)(0)
                    Dim n As String = cel.Split(New String() {"__"}, StringSplitOptions.RemoveEmptyEntries)(1)

                    worksheet.Rows(rIdx).Cells(i).Value = row.Cells(n).Value
                    i += 1
                Next
                rIdx += 1
            Next

            workbook.Save(saveFile.FileName)

            'Dim pairs As New Dictionary(Of String, String)

            'If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
            '    pairs.Add("Statement Source", "Income Statement")
            'ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
            '    pairs.Add("Statement Source", "Balance Sheet")
            'End If

            'pairs.Add("Fiscal Period ID", m_CurrentFiscalPeriod.ToString())
            'pairs.Add("Fiscal Period", lblFiscalPeriod.Text.Replace("Fiscal Period:", "").Trim())
            'pairs.Add("Layout ID", m_CurrentLayoutKey.ToString())
            'pairs.Add("Exported File Name", saveFile.FileName)

            'LogEvent("IncomeStatementExported", pairs)

        End If
    End Sub

    Private m_FlatVisibleRowsCollection As List(Of UltraGridRow)

    Private Sub getFlatVisibleRowsCollection(ByVal rows As RowsCollection, ByRef rowsCount As Integer, ByRef groupByRowsCount As Integer)

        'For Each row As UltraGridRow In ugridFinancialStatements.Rows.All
        '    If (row.HasChild()) Then
        '        Dim firstChild As UltraGridRow = row.GetChild(ChildRow.First)
        '        m_FlatVisibleRowsCollection.Add(firstChild)



        '        Dim sib As UltraGridRow = firstChild.GetSibling(SiblingRow.Next, False)

        '        While Not (sib Is Nothing)
        '            m_FlatVisibleRowsCollection.Add(sib)
        '            sib = sib.GetSibling(SiblingRow.Next, False)
        '        End While

        '    End If

        'Next

        ' Loop through every row in the passed in rows collection.
        Dim row As UltraGridRow = Nothing
        For Each row In rows

            ' If you are using Outlook GroupBy feature and have grouped rows by columns in the
            ' UltraGrid, then rows collection can contain group-by rows or regular rows. So you
            ' may need to have code to handle group-by rows as well.
            If TypeOf row Is UltraGridGroupByRow Then
                Dim groupByRow As UltraGridGroupByRow = DirectCast(row, UltraGridGroupByRow)
                ' Incremement the group-by row count.
                groupByRowsCount += 1
            Else
                ' Incremenent the regular row count.
                rowsCount += 1
            End If

            ' If the row has any child rows. Typically, there is only a single child band. However,
            ' there will be multiple child bands if the band associated with row1 has mupliple child
            ' bands. This would be the case for exmple when you have a database hierarchy in which a
            ' table has multiple child tables.
            If Not Nothing Is row.ChildBands Then


                If Not (row.ParentRow Is Nothing) Then
                    If (row.ParentRow.Expanded) Then
                        m_FlatVisibleRowsCollection.Add(row)
                    End If
                Else
                    m_FlatVisibleRowsCollection.Add(row)
                End If

                ' Loop throgh each of the child bands.
                Dim childBand As UltraGridChildBand = Nothing
                For Each childBand In row.ChildBands
                    ' Call this method recursivedly for each child rows collection.
                    Me.getFlatVisibleRowsCollection(childBand.Rows, rowsCount, groupByRowsCount)
                Next
            End If

        Next

    End Sub

    Private Sub UltraGridExcelExporter1_InitializeRow(sender As Object, e As ExcelExportInitializeRowEventArgs) Handles UltraGridExcelExporter1.InitializeRow

        'supress colapsed rows
        If Not (e.Row.ParentRow Is Nothing) Then
            If Not (e.Row.ParentRow.Expanded) Then
                e.SkipRow = True
            End If
        End If

        If Not (e.SkipRow) And Not (e.Row.Appearance.BackColor = Color.AliceBlue) And Not (e.Row.Appearance.BackColor = Color.LightGray) Then

            For Each cell As UltraGridCell In e.Row.Cells
                If (cell.Appearance.ForeColor = Color.White) Then
                    'cell.Appearance.BackColor = HierarchyColors.Item(CInt(e.Row.Cells("Level").Value))
                    cell.Appearance.ForeColor = Color.Empty
                    cell.Appearance.BorderColor = Color.Empty
                End If
            Next

        End If

        'set the hierarchy colors
        e.Row.Appearance.BackColor = HierarchyColors.Item(CInt(e.Row.Cells("Level").Value))

        e.CurrentColumnIndex = 0
        'bug with v10.2 infragistics, where the coluns do not line up when exported.  though when I manually set the colunindex to zero and force all rows to the left hand side, we lose the expand/colapse inside the excel document.

    End Sub

    Private Sub UltraGridExcelExporter1_SummaryRowExporting(sender As System.Object, e As Infragistics.Win.UltraWinGrid.ExcelExport.SummaryRowExportingEventArgs) Handles UltraGridExcelExporter1.SummaryRowExporting
        'e.Cancel = True
        e.CurrentColumnIndex = 0
    End Sub

    Private Sub UltraGridExcelExporter1_InitializeSummary(sender As System.Object, e As Infragistics.Win.UltraWinGrid.ExcelExport.InitializeSummaryEventArgs) Handles UltraGridExcelExporter1.InitializeSummary
        Dim sum As SummarySettings = e.Summary
    End Sub

#End Region

#Region "printing"

    Private Sub UltraGrid1_InitializeRow(sender As Object, e As InitializeRowEventArgs) Handles ugridFinancialStatements.InitializeRow


        Try

            Dim acNum As String = e.Row.GetCellValue("AccountNumber")

            If (acNum = "///") Then

                ' here we need to supress the display of amounts in cells, as there are summaries that now display this information.
                'For Each cell As UltraGridCell In e.Row.Cells

                '    If Not (cell.Column.Key = "Description") Then
                '        cell.Appearance.BackColor = Color.White
                '        cell.Appearance.ForeColor = cell.Appearance.BackColor
                '        cell.Appearance.BorderColor = cell.Appearance.BackColor
                '    Else
                '        'cell.Appearance.BorderColor = Color.Black
                '        'cell.Appearance.BorderColor2 = Color.Black
                '        cell.Appearance.BackColor = Color.MintCream
                '    End If
                'Next
                e.Row.Cells("Description").Appearance.BackColor = Color.MintCream
            Else
                e.Row.Appearance.BackColor = Color.LightGray
            End If

            '' We only want to do this for print rows, not real rows in the on-screen grid.
            'If (e.Row.Band.Layout.IsPrintLayout) Then

            '    Dim realGridRow As UltraGridRow = ugridFinancialStatements.GetRowFromPrintRow(e.Row)
            '    e.Row.Expanded = realGridRow.Expanded

            '    If Not (e.Row.ParentRow Is Nothing) Then

            '        'If Not (realGridRow.ParentRow.Expanded) Then
            '        '    e.Row.Hidden = True
            '        'End If

            '        'If Not (e.Row.Expanded) Then
            '        '    e.Row.Band.Summaries.Clear()
            '        '    SetSummaries(e.Row.Band.Layout)
            '        'End If
            '        e.Row.ParentRow.Expanded = realGridRow.ParentRow.Expanded
            '    End If

            'End If

        Catch ex As Exception
            Dim bah As String = ""
        End Try

    End Sub

    Private Sub StartPrintingGirdLayout()

        PageSetupDialog1.Document = c_pdSetup
        If (PageSetupDialog1.ShowDialog() = Windows.Forms.DialogResult.OK) Then

            ugridFinancialStatements.PrintPreview(ugridFinancialStatements.DisplayLayout, c_pdSetup)
            If (MessageBox.Show("Do you wish to print?", "Print", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1) = Windows.Forms.DialogResult.Yes) Then

                ugridFinancialStatements.Print(ugridFinancialStatements.DisplayLayout, c_pdSetup)

                'Dim pairs As New Dictionary(Of String, String)

                'If (m_DataSourceMode = DataSourceMode.IncomeStatement) Then
                '    pairs.Add("Statement Source", "Income Statement")
                'ElseIf (m_DataSourceMode = DataSourceMode.BalanceSheet) Then
                '    pairs.Add("Statement Source", "Balance Sheet")
                'End If

                'pairs.Add("Fiscal Period ID", m_CurrentFiscalPeriod.ToString())
                ''pairs.Add("Fiscal Period", lblFiscalPeriod.Text.Replace("Fiscal Period:", "").Trim())
                'pairs.Add("Layout ID", m_CurrentLayoutKey.ToString())

                'LogEvent("IncomeStatementPrinted", pairs)

            End If
        End If

    End Sub

    Private Sub ugridFinancialStatements_InitializePrintPreview(sender As System.Object, e As Infragistics.Win.UltraWinGrid.CancelablePrintPreviewEventArgs) Handles ugridFinancialStatements.InitializePrintPreview
        AddPrintedHeader(e.DefaultLogicalPageLayoutInfo, e.PrintLayout)
    End Sub

    Private Sub ugridFinancialStatements_InitializePrint(sender As System.Object, e As Infragistics.Win.UltraWinGrid.CancelablePrintEventArgs) Handles ugridFinancialStatements.InitializePrint
        AddPrintedHeader(e.DefaultLogicalPageLayoutInfo, e.PrintLayout)
    End Sub

    Private Sub AddPrintedHeader(ByRef v_PrintLayout As Infragistics.Win.UltraWinGrid.LogicalPageLayoutInfo, ByVal v_DisplayLayout As UltraGridLayout)
        Dim ret As String = "" 'posSettings.Name & vbCrLf

        'If (m_DataSourceMode = DataSourceMode.BalanceSheet) Then

        '    ret &= "Balance Sheet" & vbCrLf
        'ElseIf (m_DataSourceMode = DataSourceMode.IncomeStatement) Then

        '    ret &= "Income Statement" & vbCrLf
        '    If Not (m_menuItems_Layouts.Text.Contains("(None)")) Then

        '        Dim ly As String = m_menuItems_Layouts.Text.Remove(m_menuItems_Layouts.Text.LastIndexOf(")")).Replace("Selected Layout (", "")
        '        ret &= ly & vbCrLf
        '    End If
        'End If

        'ret &= lblFiscalPeriod.Text & vbCrLf
        ret &= DateTime.Now.ToString() & vbCrLf
        v_PrintLayout.PageHeader = vbCrLf & ret & vbCrLf

        'v_PrintLayout.PageHeaderAppearance.Image = New Bitmap(m_ClubLogo)

        v_PrintLayout.PageHeaderAppearance.ImageHAlign = HAlign.Left
        v_PrintLayout.PageHeaderAppearance.ImageVAlign = VAlign.Middle
        v_PrintLayout.PageHeaderBorderStyle = UIElementBorderStyle.Default
        v_PrintLayout.PageHeaderAppearance.FontData.Bold = DefaultableBoolean.True
        v_PrintLayout.PageHeaderAppearance.FontData.SizeInPoints = 12
        v_PrintLayout.PageHeaderAppearance.TextHAlign = HAlign.Center
        v_PrintLayout.PageHeaderAppearance.TextVAlign = VAlign.Middle

        v_PrintLayout.ColumnClipMode = ColumnClipMode.RepeatClippedColumns
        v_PrintLayout.ClipRowBehavior = ClipRowBehavior.CellBased

        v_PrintLayout.PageFooter = "Page <#>"
        v_PrintLayout.PageFooterAppearance.FontData.SizeInPoints = 6
        v_PrintLayout.PageFooterAppearance.TextHAlign = HAlign.Right

        '  SetSummaries(v_DisplayLayout)

    End Sub

#End Region


    Private Sub btnPrint_Click(sender As System.Object, e As System.EventArgs) Handles btnPrint.Click
        StartPrintingGirdLayout()
    End Sub

    Private Sub btnExcelExport_Click(sender As System.Object, e As System.EventArgs) Handles btnExcelExport.Click
        btnExportToExcel_Click(sender, e)
    End Sub
End Class
